(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: kstenIMPORTE.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:05 $
# $Revision: 1.1.1.1 $
Bemerkungen:

IMPLEMENTATION MODULE KstenIMPORTE   TS-Import-Schnittstelle Kostenstellen

Erstersteller :Sigrid Preuss
Implementation : Schoenhammer Herbert
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE KstenIMPORTE;      (* IMPORT-Schnittstelle des TS_Ksten *)



 (* TS Kostenstellen *)

 IMPORT VDat;
 IMPORT SysDat;
 FROM Datum IMPORT TDatum;
 FROM String IMPORT TString;


 (* TYPDEKLARATIONEN *)

 (* TYPE THandle = VDat.THandleInVDat; *)
 (* TFileModus = VDat.TModusInVDat;*)



(* Durchreichungen an das TS_SysDat                                           *)
(*============================================================================*)


PROCEDURE LiesSystemDatumInSysDat () : TDatum;
(* Liest das HiKS-Tagesdatum *)
BEGIN 
   RETURN SysDat.LiesSystemDatumInSysDat ();
END LiesSystemDatumInSysDat;

(* Durchreichungen an das TS_VDat                                             *)
(*============================================================================*)


PROCEDURE ReadLineInVDat (inH:THandle; VAR inoutString : TString; 
                          VAR inoutMessage : TString) : BOOLEAN;
BEGIN 
   RETURN VDat.ReadLineInVDat (inH, inoutString, inoutMessage)
END ReadLineInVDat;


PROCEDURE WriteLineInVDat (inH:THandle; VAR inoutString : TString; 
                          VAR inoutMessage : TString) : BOOLEAN;
BEGIN 
   RETURN VDat.WriteLineInVDat (inH, inoutString, inoutMessage)
END WriteLineInVDat;


PROCEDURE EofInVDat (inH:THandle) : BOOLEAN;
BEGIN
   RETURN VDat.EofInVDat (inH);
END EofInVDat;

END KstenIMPORTE.






