IMPLEMENTATION MODULE FAnlegenVtrHKB;

FROM SYSTEM   IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen,JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;
FROM args     IMPORT GetArgs, ArgTable;
FROM InOut    IMPORT WriteString,WriteLn,WriteInt;
IMPORT WholeStr;
IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT FLadenSysVw;
IMPORT Datum;
IMPORT HKe;
IMPORT Ksten;
IMPORT Vtre;
IMPORT SysDat;
IMPORT DialogLib;

TYPE TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;
VAR
  FensterHandle				: ADDRESS;
  VaterFenster				: ADDRESS;
  Vater        				: ADDRESS;
  EndeKnopfHandle			: ADDRESS;
  WeiterKnopfHandle		: ADDRESS;
  VtrSpeichKnopfHdle	: ADDRESS;
  PersIdZeile					: ADDRESS;
  KstIdZeile					: ADDRESS;
  StundenzahlZeile	  : ADDRESS;
  TaetigkeitZeile	    : ADDRESS;
  BegruendungZeile	  : ADDRESS;
  GueltigVonZeile	    : ADDRESS;
  GueltigBisZeile	    : ADDRESS;
  ErstellDatZeile     : ADDRESS;
  KstenListeHdle	    : ADDRESS;
  HkeListeHdle        : ADDRESS;
  Meldung1            : ADDRESS;
  HKeStringliste      : Stringliste.TStringliste;
  KstStringliste      : Stringliste.TStringliste;

(*----------------------------------------------------------------------------------------*)

PROCEDURE InitMaske();
VAR Titel,
    Leerstring  : String.TString;
BEGIN
  Leerstring := String.Create();
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,550,300,CAST(PROC,EndeKnopfCallback));
  (*
  String.Schreibe(Titel,"PrsID");
  PersIdZeile := StelleZeileDar(Titel,Leerstring,32,FensterHandle,360,60);
  String.Schreibe(Titel,"KstID");
  KstIdZeile := StelleZeileDar(Titel,Leerstring,32,FensterHandle,360,90);
  *)
  String.Schreibe(Titel,"-->Eingabe besttigen");
  WeiterKnopfHandle := StelleKnopfDar(Titel,FensterHandle,410,180,CAST(PROC,WeiterKnopfCallback));
END InitMaske;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
  EntferneKnopf(EndeKnopfHandle);
  EntferneFenster(FensterHandle);
  Dispose();
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE VtrSpeichKnopfCallback();
(* HK-ID erzeugen,Kst - Id erzeugen,Vtr erzeugen, Dialogfelder
   in die ID`s und in Vtr-Ado
   einlesen,abspeichern des Vertrages
*)
VAR sPersonalID  : String.TString;
    sKostenStID  : String.TString;
    sStundenzahl : String.TString;
    sTaetigkeit  : String.TString;
    sBegruendung : String.TString;
    sGueltigVon  : String.TString;
    sGueltigBis  : String.TString;
    sErstellDat  : String.TString;
    errmsg  : String.TString;
    meldString   : String.TString;
    Titel        : String.TString;
    HilfString   : String.TString;
    HilfsKrID    : HKe.TPersID;
    KstStID      : Ksten.TKstID;
    Vertrag      : Vtre.TVtr;
    CORRECT      : BOOLEAN;
    VonDatum  	 : Datum.TDatum;
    BisDatum		 : Datum.TDatum;
    ErstellDatum : Datum.TDatum;
    StdAsCARD    : CARDINAL;
    message      : ARRAY[0..255] OF CHAR;
    result       : WholeStr.ConvResults;

(*-------------------------------Lokale Procedure-------------------------------*)
    PROCEDURE TestPersID() : BOOLEAN;
    VAR s        : String.TString;
     BEGIN
     IF (String.Laenge(sPersonalID) >= 5)THEN
      RETURN TRUE
     ELSE
      s := String.Create();
      String.Schreibe(s,"Fehlerhafte PersID");
      MeldungAnzeigen(s);
      String.Dispose(s);
      RETURN FALSE;
     END;
    END TestPersID;
(*-------------------------------Lokale Procedure--------------------------------*)

    PROCEDURE TestKstenID() : BOOLEAN;
    VAR s        : String.TString;
    BEGIN
     IF (String.Laenge(sKostenStID) >= 5) THEN
      RETURN TRUE;
     ELSE
      s := String.Create();
      String.Schreibe(s,"Fehlerhafte KstID");
      MeldungAnzeigen(s);
      String.Dispose(s);
      RETURN FALSE;
     END;
    END TestKstenID;
(*-------------------------------Lokale Procedure---------------------------------*)

    PROCEDURE TestStdZahl() : BOOLEAN;
    VAR ok : BOOLEAN;
        s  : String.TString;
    BEGIN
       CASE result OF
         WholeStr.strAllRight      : WriteString("VtrSpeichKnopfCallback: sStundenzahl o.k");
      	  	  					             WriteLn();
      	  	  					             ok := TRUE;
         | WholeStr.strOutOfRange  : WriteString("VtrSpeichKnopfCallback:");
    														     WriteString("sStundenzahl - Bereichsfehler"); WriteLn;
       												       ok := FALSE;
         | WholeStr.strWrongFormat : WriteString("VtrSpeichKnopfCallback:");
     														     WriteString("sStundenzahl - Formatfehler");   WriteLn;
                        				     ok := FALSE;
         | WholeStr.strEmpty       : WriteString("VtrSpeichKnopfCallback:");
    														     WriteString("sStundenzahl - LeererString");   WriteLn;
                                     ok := FALSE;
      END;
      IF ok THEN
        RETURN(TRUE);
      ELSE
        s := String.Create();
        String.Schreibe(s,"Stundenzahl: Fehlerhafte eingabe");
        MeldungAnzeigen(s);
        RETURN(FALSE);
      END;
    END TestStdZahl;
(*-------------------------------Lokale Procedure---------------------------------*)

    PROCEDURE TestTaetigkeit() : BOOLEAN;
    VAR errmsg   : String.TString;
    BEGIN
     RETURN TRUE;
    END TestTaetigkeit;

(*-------------------------------Lokale Procedure---------------------------------*)

    PROCEDURE TestGueltigVon() : BOOLEAN;
    VAR errmsg   : String.TString;
        s        : String.TString;
    BEGIN
     IF DialogLib.DatumKorrekt(sGueltigVon,errmsg) THEN
       WriteString(StC(errmsg));
       RETURN TRUE;
     ELSE
       s := String.Create();
       String.Schreibe(s,"GueltigVon: ");
       String.Anhaengen(errmsg,s);
       MeldungAnzeigen(s);
       String.Dispose(s);
       RETURN FALSE;
     END;
     String.Dispose(errmsg);
    END TestGueltigVon;
(*------------------------------Lokale Procedure-----------------------------------*)

    PROCEDURE TestGueltigBis() : BOOLEAN;
    VAR errmsg  : String.TString;
        s       : String.TString;
    BEGIN
     IF DialogLib.DatumKorrekt(sGueltigBis,errmsg) THEN
         WriteString(StC(errmsg));
       RETURN TRUE;
     ELSE
       s := String.Create();
       String.Schreibe(s,"GueltigBis: ");
       String.Anhaengen(errmsg,s);
       MeldungAnzeigen(s);
       String.Dispose(s);
       RETURN FALSE;
     END;
     String.Dispose(errmsg);
    END TestGueltigBis;

(*----------------------------------------------------------------------------------*)

BEGIN
  CORRECT := TRUE;

  (* Lokale Varialblen Initialisieren *)
  sPersonalID  := String.Create();
  sKostenStID  := String.Create();
  sStundenzahl := String.Create();
  sTaetigkeit  := String.Create();
  sBegruendung := String.Create();
  sGueltigVon  := String.Create();
  sGueltigBis  := String.Create();
  sErstellDat  := String.Create();

  (* Dialogfelder einlesen *)
  LiesZeile(PersIdZeile,sPersonalID);
  WriteString(StC(sPersonalID));WriteLn();
  LiesZeile(KstIdZeile,sKostenStID);
  LiesZeile(StundenzahlZeile,sStundenzahl);
  LiesZeile(TaetigkeitZeile,sTaetigkeit);
  LiesZeile(BegruendungZeile,sBegruendung);
  LiesZeile(GueltigVonZeile,sGueltigVon);
  LiesZeile(GueltigBisZeile,sGueltigBis);
  LiesZeile(ErstellDatZeile,sErstellDat);
  (* Die eingelesenen Strings in die ADO - Felder einlesen *)


  (* Teste die Formulareingaben auf Korrektheit *)

  CORRECT := TestPersID();
  IF CORRECT THEN
    Cut(sPersonalID,0,5);
  END;

  IF CORRECT THEN
   CORRECT := TestKstenID();
  END;

  IF CORRECT THEN
   Cut(sKostenStID,0,5);
  END;

  IF CORRECT THEN
   WholeStr.StrToCard(StC(sStundenzahl),StdAsCARD,result);
   CORRECT := TestStdZahl();
  END;

  IF CORRECT THEN
   CORRECT := TestTaetigkeit();
  END;

  IF CORRECT THEN
   CORRECT := TestGueltigVon();
  END;

  IF CORRECT THEN
   CORRECT := TestGueltigBis();
  END;

  (* Falls Eingaben korrekt, erzeuge Vertrag V und bertrage die Eingaben nach V
     falls Fehler auftreten, Abbruch des Prozesses und Rckkehr zum Hauptfenster
     die Fehlermeldungen werden auf der Konsole ausgegeben *)
  IF CORRECT THEN
    Vertrag := Vtre.CreateVtr();
  END;

  IF CORRECT THEN

   (* Setze Vertrag.PersonalID *)
   HilfsKrID := HKe.StringInPersID(sPersonalID);
   Vtre.SetzePersIDinVtr (Vertrag,HilfsKrID);


   (* Setze Vertrag.KostenstellenID *)
   KstStID := Ksten.StringInKstID (sKostenStID);
   Vtre.SetzeKstIDinVtr (Vertrag,KstStID);

   (* Setze Vertrag.Stundenzahl *)
   IF (CORRECT = FALSE) THEN
      meldString := String.Create();
      String.Schreibe(meldString,"Stundenzahl: Formatfehler");
      MeldungAnzeigen(meldString);
      String.Dispose(meldString);
   END;

   IF CORRECT THEN
    CORRECT := Vtre.SetzeStdzahlinVtr(Vertrag,StdAsCARD);
   END;

   (* Setze Vertrag.Taetigkeit*)
   IF CORRECT THEN
    CORRECT   := Vtre.SetzeTaetigktinVtr (Vertrag,sTaetigkeit)
   END;

   (* Setze Vertrag.Begruendeung*)
   IF CORRECT THEN
    CORRECT   := Vtre.SetzeBegruendinVtr (Vertrag,sBegruendung);
   END;

   (* String nach Datum*)

   IF CORRECT THEN
    VonDatum := Datum.CreateDatum();
    CORRECT  := Datum.DatumVonString (sGueltigVon,VonDatum,errmsg);
    WriteString(StC(errmsg));WriteLn();
    IF NOT(CORRECT) THEN
    	HilfString := String.Create();
    	String.Schreibe(HilfString,"GueltigVon: ");
    	String.Anhaengen(errmsg,HilfString);
    	MeldungAnzeigen(HilfString);
    	String.Dispose(HilfString);
    END;
   END;

   (* String nach Datum *)
   IF CORRECT THEN
    BisDatum := Datum.CreateDatum();
    CORRECT  := Datum.DatumVonString(sGueltigBis,BisDatum,errmsg);
    WriteString(StC(errmsg));WriteLn();
    IF NOT(CORRECT) THEN
    	HilfString := String.Create();
    	String.Schreibe(HilfString,"GueltigBis: ");
    	String.Anhaengen(errmsg,HilfString);
    	MeldungAnzeigen(HilfString);
    	String.Dispose(HilfString);
    END;
   END;


   (* String nach Datumg*)
   IF CORRECT THEN
    CORRECT := Datum.DatumVonString(sErstellDat,ErstellDatum,errmsg);
    WriteString(StC(errmsg));WriteLn();
   END;

   (* Setze Vertrag.GueltigVon und Vertrag.Gueltig.Bis und Vertrag.Erstellungsdatum *)
   IF CORRECT THEN
    Vtre.SetzeGueltigVoninVtr (Vertrag,VonDatum);
    Vtre.SetzeGueltigBisinVtr (Vertrag,BisDatum);
    CORRECT := Vtre.SetzeErstellDatinVtr(Vertrag,ErstellDatum);
   END;

   IF CORRECT THEN
    WriteString("VtrSpeichKnopfCallback: Vtr erzeugt und initialisiert"); WriteLn();
   ELSE
    WriteString("VtrSpeichKnopfCallback: Erzeugung der Vetr.Daten milungen");
   END;

  END;

  (* Falls CORRECT dann Vertrag abspeichern *)
  IF CORRECT THEN
    CORRECT := Vtre.InsertVtr( Vertrag,errmsg);
    WriteString("VtrSpeichKnopfCallback: ");WriteString(StC(errmsg));
    WriteLn;
  END;

  (* Abschlumeldungen ber Erfolg/Mierfolg ber Anlegen eines Neuvertrages*)
  IF CORRECT THEN
    (* Formular entfernen *)
    EntferneKnopf(VtrSpeichKnopfHdle);
    EntferneZeile(PersIdZeile);
    EntferneZeile(KstIdZeile);
    EntferneZeile(StundenzahlZeile);
    EntferneZeile(BegruendungZeile);
    EntferneZeile(TaetigkeitZeile);
    EntferneZeile(GueltigVonZeile);	
    EntferneZeile(GueltigBisZeile);
    EntferneZeile(ErstellDatZeile);
    meldString := String.Create();
    String.Schreibe(meldString," Vertrag erzeugt und gespeichert ");
    Meldung1 := StelleMeldungDar(meldString,TRUE,FensterHandle,250,150);
    String.Dispose(meldString);
  ELSE
    (* Neuerzeugung oder Einfuegen des Vertrages milungen-->Konsolenausgabe *)
    WriteString(" Vertrag Anlegen milungen ");
  END;

  (* Aufrumen *)
  String.Dispose(sPersonalID);
  String.Dispose(sKostenStID);
  String.Dispose(sStundenzahl);
  String.Dispose(sTaetigkeit);
  String.Dispose(sBegruendung);
  String.Dispose(sGueltigVon);
  String.Dispose(sGueltigBis);
  String.Dispose(sErstellDat);

END VtrSpeichKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowContentsOfHke();
VAR  s        : String.TString;
     strlist  : Stringliste.TStringliste;

BEGIN
   WriteString("ShowContentsOfHKe1");WriteLn();
   HKeStringliste := HKe.GibHKeAlsStringlisteinHKe();
    WriteString("ShowContentsOfHKe2");WriteLn();
  (* Gib die Hilfskraefte in sortierter Reihenfolge (nach Familienname) mit
   folgender Formatierung als Stringliste aus;
   Formatierung: PersId (5Zeichen), 1 Leerzeichen, Familienname(25Zeichen),
   1 Leerzeichen, Vorname (15Zeichen), 1 Leerzeichen, Wohnort (10Zeichen)
   insgesamt also 58Zeichen. *)

            (* Simulation der Stringliste aus dem HKe - Ordner *)
   (*
   HKeStringliste := Stringliste.Create();  *)

   s := String.Create();

   (* Testdaten zur Simulation der Hke - Liste *)
   (*
   String.Schreibe(s,"00001 Mario Winter");
   Stringliste.Insert(HKeStringliste,s);
   String.Schreibe(s,"00002 Herbert Schnhammer ");
   Stringliste.Insert(HKeStringliste,s);
   String.Schreibe(s,"00003 Johannes Magauer ...sfdgsdfgsdfg.....");
   Stringliste.Insert(HKeStringliste,s);
   String.Schreibe(s,"00004 Sigrid Preuss ......sdfgsdsdfgsdgsdgsdfggsdgf...");
   Stringliste.Insert(HKeStringliste,s);
   String.Schreibe(s,"00005 Johann Zeisel");
   Stringliste.Insert(HKeStringliste,s);
   String.Schreibe(s,"00006 H.G.Werfels");
   Stringliste.Insert(HKeStringliste,s);
   String.Schreibe(s,"00007, Gabi Hawlena");
   String.Schreibe(s," PersID       Name");
   *)


   (* Aufbau der verkrzten Stringliste *)
   strlist := Stringliste.Create();
   Stringliste.GoStart(HKeStringliste);
   WriteString("ShowContentsOfHKe3");WriteLn();
   WHILE NOT Stringliste.OffEnd(HKeStringliste) DO
   	s := Stringliste.Current(HKeStringliste);
   	Cut(s,0,32);
   	Stringliste.Append(strlist,s);
   	Stringliste.StepNext(HKeStringliste);
   END;
    WriteString("ShowContentsOfHKe4");WriteLn();
   (*Darstellung der Liste *)
   String.Schreibe(s,"  Id    Name   ");
   HkeListeHdle := StelleListeDar(strlist,s,4,FensterHandle,60,50,CAST(PROC,HkeListeCallback));

   Stringliste.Dispose(strlist);
   Stringliste.Dispose(HKeStringliste);
   String.Dispose(s);

END ShowContentsOfHke;

(*----------------------------------------------------------------------------------------*)

PROCEDURE HkeListeCallback(element : INTEGER);
VAR Titel   : String.TString;
    Text : String.TString;
BEGIN
  Text := String.Create();
  LiesListenelement(HkeListeHdle,element,Text);
  Titel := String.Create();
  String.Schreibe(Titel,"PrsID");
  EntferneZeile(PersIdZeile);
  PersIdZeile :=  StelleZeileDar(Titel,Text,32,FensterHandle,360,60);
  String.Dispose(Titel);
  String.Dispose(Text);
END HkeListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowContentsOfKsten();
VAR  StrListe : Stringliste.TStringliste;
     s : String.TString;

BEGIN
   s := String.Create();
   WriteString("ShowContentsOfKsten1");WriteLn();
   KstStringliste := Ksten.GibKstenAlsStringlisteInKsten();

  (* -- Vorbed.: Kostenstellenordner existiert
     -- Erzeug1t ein nues Rueckgabe-ADO strliste vom Typ TStringliste.
     -- In jedem String werden ausgewhlte Attribute einer Kostenstellen
     -- lesbar ausgegeben. Bercksichtigt werden nur nicht liquidierte
     -- Kostenstellen. Ausgabe mit Formatierung:
	      KstenID    ( 5 Zeichen); 1 Leerzeichen;
        Name       (20 Zeichen); 1 Leerzeichen;
        Jahr       ( 4 Zeichen); 1 Leerzeichen;
        Sperrdatum wenn vorhanden, sonst Leerzeichen (10Zeichen);
	  insgesamt also 42 Zeichen
     -- Nachbed.: strliste existiert
   *)


                      (* Simulation der KstenStringliste *)



   (* Testdaten zur Simulation der Ksten - Liste *)
   (*
   KstStringliste := Stringliste.Create();
   String.Schreibe(s,"00001 irgendeine Kostenstelle");
   Stringliste.Insert(KstStringliste,s);
   String.Schreibe(s,"00002 irgendeine Kostenstelle....");
   Stringliste.Insert(KstStringliste,s);
   String.Schreibe(s,"00003 irgendeine Kostenstelle.");
   Stringliste.Insert(KstStringliste,s);
   String.Schreibe(s,"00004 irgendeine Kostenstelle");
   Stringliste.Insert(KstStringliste,s);
   String.Schreibe(s,"00005 irgendeine ");
   Stringliste.Insert(KstStringliste,s);
   String.Schreibe(s,"00006 irgendeine Kostenstelle");
   Stringliste.Insert(KstStringliste,s);
   String.Schreibe(s,"00007 irgendeine Kostenstelle.af....");
   *)

   (* Aufbau der verkrzten Stringliste *)
   StrListe := Stringliste.Create();
   Stringliste.GoStart(KstStringliste);
   WHILE NOT Stringliste.OffEnd(KstStringliste) DO
   	s := Stringliste.Current(KstStringliste);
   	Cut(s,0,26);
   	Stringliste.Append(StrListe,s);
   	Stringliste.StepNext(KstStringliste);
   END;
   WriteString("ShowContentsOfKsten3");WriteLn();
   String.Schreibe(s,"  ID    Kostenstelle");
   KstenListeHdle := StelleListeDar(StrListe,s,4,FensterHandle,60,170,
   																	CAST(PROC,KstenListeCallback));

   (* Stringliste.Dispose(StrListe); *)
   Stringliste.Dispose(KstStringliste);
   String.Dispose(s);

END ShowContentsOfKsten;

(*----------------------------------------------------------------------------------------*)

PROCEDURE KstenListeCallback(element : INTEGER);
VAR Titel   : String.TString;
    Text    : String.TString;
BEGIN
  Text := String.Create();
  LiesListenelement(KstenListeHdle,element,Text);
  Titel := String.Create();
  String.Schreibe(Titel,"KstID");
  EntferneZeile(KstIdZeile);
  KstIdZeile :=  StelleZeileDar(Titel,Text,32,FensterHandle,360,90);
  String.Dispose(Titel);
  String.Dispose(Text);
END KstenListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE WeiterKnopfCallback();
VAR Abfragetext : String.TString;
    Titel       : String.TString;
    Leerstring  : String.TString;
    HeuteString : String.TString;
    Heute       : Datum.TDatum;
BEGIN
  IF NOT((PersIdZeile = NIL) OR (KstIdZeile = NIL)) THEN
  	EntferneListe(KstenListeHdle);
  	EntferneListe(HkeListeHdle);
  	EntferneKnopf(WeiterKnopfHandle);
  	Leerstring := String.Create();
  	Titel := String.Create();
  	String.Schreibe(Titel,"Stundenzahl");
  	StundenzahlZeile := StelleZeileDar(Titel,Leerstring,4,FensterHandle,60,120);
  	String.Schreibe(Titel,"Taetigkeit");
  	TaetigkeitZeile := StelleZeileDar(Titel,Leerstring,40,FensterHandle,60,150);
  	String.Schreibe(Titel,"Begruendung");
  	BegruendungZeile := StelleZeileDar(Titel,Leerstring,50,FensterHandle,60,180);
  	String.Schreibe(Titel,"GueltigVon");
  	GueltigVonZeile := StelleZeileDar(Titel,Leerstring,10,FensterHandle,60,210);
  	String.Schreibe(Titel,"GueltigBis");
  	GueltigBisZeile := StelleZeileDar(Titel,Leerstring,10,FensterHandle,60,240);
  	String.Schreibe(Titel,"Erstellungsdatum");
  	String.Dispose(Leerstring);
  	
  	Heute       := SysDat.LiesSystemDatumInSysDat();
  	HeuteString := String.Create();
  	String.Schreibe(HeuteString,StC(Datum.DatumAlsString(Heute)));
  	ErstellDatZeile := StelleZeileDar(Titel,HeuteString,10,FensterHandle,60,270);
    String.Dispose(HeuteString);

  	String.Schreibe(Titel,"Vertrag Speichern");
  	
  	VtrSpeichKnopfHdle := StelleKnopfDar(Titel,FensterHandle,310,300,
  	                                     CAST(PROC,VtrSpeichKnopfCallback));
  END
END WeiterKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel : String.TString;
BEGIN
  PersIdZeile := NIL;
  KstIdZeile  := NIL;
  Vater := inFunct;
  Titel := String.Create();
  String.Schreibe(Titel,"V e r t r a g   E r z e u g e n  &  B u c h e n");
  FensterHandle :=  NeuesFenster( Titel,140,80,400,800);
  InitMaske();
  WriteString("Aufruf ShowContensOFHke");WriteLn;
  ShowContentsOfHke();
  WriteString("Aufruf ShowContenOfKsten");WriteLn;
  ShowContentsOfKsten();
END Create;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
    WriteString("FLadenSysVw.Dispose");WriteLn;
    EntferneKnopf(EndeKnopfHandle);
    EntferneFenster(FensterHandle);
    AktiviereVater := CAST(TActVater,Vater);
    AktiviereVater();
END Dispose;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Cut(VAR inoutString : String.TString;inStart,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inoutString, dannRckgabe via inoutString*)
VAR ok : BOOLEAN;
BEGIN
  IF (String.Laenge(inoutString) >= 5) THEN
    String.Auslesen (inoutString,inStart,inAnzahl,inoutString);
  END;
END Cut;

(*----------------------------------------------------------------------------------------*)


PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach ARRAY OF CHAR = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)


END FAnlegenVtrHKB.

