(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: SysHK.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 10:17:28 $
# $Revision: 1.2 $

*)
(******************************************************************************)
 
MODULE SysHK;


FROM HKe IMPORT THK, TPersID, CreateHK, DisposeHK, DuplicateHK, IsEqualHK, EqualizeHK,
PruefePersID, LiesNameinHK, SetzeNameinHK,
LiesVornameinHK, SetzeVornameinHK, LiesGeburtsdatuminHK,
SetzeGeburtsdatuminHK, LiesGeschlechtinHK, SetzeGeschlechtinHKeHK,
LiesStrasseinHK, SetzeStrasseinHK, LiesPostleitzahlinHK,
SetzePostleitzahlinHK, LiesStadtinHK, SetzeStadtinHK, LiesLandinHK,
SetzeLandinHK, LiesTelefoninHK, SetzeTelefoninHK, LiesFaxinHK, SetzeFaxinHK,
LieseMailinHK, SetzeMailinHK, LiesDienstStrinHK, SetzeDienstStrinHK,
LiesDienstPlzinHK, SetzeDienstPlzinHK, LiesDienstStadtinHK,
SetzeDienstStadtinHK, LiesDienstLandinHK, SetzeDienstLandinHK,
LiesDienstTelinHK, SetzeDienstTelinHK, LiesDienstFaxinHK, SetzeDienstFaxinHK,
LiesDiensteMailinHK, SetzeDiensteMailinHK, LiesGeburtsortinHK,
SetzeGeburtsortinHK, LiesStaatsanginHK, SetzeStaatsanginHK, LiesFamstandinHK,
SetzeFamstandinHK, LiesKinderinHK, SetzeKinderinHK, LiesBankinstOrtinHK,
SetzeBankinstOrtinHK, LiesBlzinHK, SetzeBlzinHK, LiesKontonrinHK,
SetzeKontonrinHK, LiesAbschlussinHK, SetzeAbschlussinHK, LiesPersonalnrinHK,
SetzePersonalnrinHK, LiesBemerkungeninHK, SetzeBemerkungeninHK,
LiesPraestageinHK, SetzePraestageinHK, LiesInteresseninHK,
SetzeInteresseninHK, LiesVerfuegAbinHK, SetzeVerfuegAbinHK,
LiesVorStdzahlinHK, SetzeVorStdzahlinHK, PersIDAlsString, StringInPersID,
ExistiertPersIDHK, LiesPersIDHK, SearchHK, GibHKeAlsStringlisteInHke;

FROM Datum 	IMPORT 	TDatum, DatumAlsString, DatumVonString;
FROM String 	IMPORT 	TString;
FROM Stringliste IMPORT TStringliste;

FROM HKB	IMPORT  LoeschenHK, AufnehmenHK, LoeschenHK;


VAR
HK:THK;
pers:TPersID;

true:BOOLEAN;
str:TString;
strl:TStringliste;
dat:TDatum;
c:CHAR;
card:CARDINAL;


BEGIN


HK:=CreateHK();
DisposeHK(HK);
HK:=DuplicateHK (HK);
true:=IsEqualHK (HK,HK);
EqualizeHK (HK, HK);
true:=PruefePersID (str, str);
str:=LiesNameinHK (HK);
SetzeNameinHK (HK,str);
str:=LiesVornameinHK (HK);
SetzeVornameinHK (HK, str);
dat:=LiesGeburtsdatuminHK (HK);
SetzeGeburtsdatuminHK (HK, dat);
c:=LiesGeschlechtinHK (HK);
SetzeGeschlechtinHKeHK (HK, c);
str:=LiesStrasseinHK (HK);
SetzeStrasseinHK (HK, str);
str:=LiesPostleitzahlinHK (HK);
SetzePostleitzahlinHK (HK, str);
str:=LiesStadtinHK (HK);
SetzeStadtinHK (HK, str);
str:=LiesLandinHK (HK);
SetzeLandinHK (HK, str);
str:=LiesTelefoninHK (HK);
SetzeTelefoninHK (HK, str);
str:=LiesFaxinHK (HK);
SetzeFaxinHK (HK, str);
str:=LieseMailinHK (HK);
SetzeMailinHK (HK, str);
str:=LiesDienstStrinHK (HK);
SetzeDienstStrinHK (HK, str);
str:=LiesDienstPlzinHK (HK);
SetzeDienstPlzinHK(HK, str);
str:=LiesDienstStadtinHK (HK);
SetzeDienstStadtinHK (HK, str);
str:=LiesDienstLandinHK (HK);
SetzeDienstLandinHK (HK, str);
str:=LiesDienstTelinHK (HK);
SetzeDienstTelinHK (HK, str);
str:=LiesDienstFaxinHK (HK);
SetzeDienstFaxinHK (HK, str);
str:=LiesDiensteMailinHK (HK);
SetzeDiensteMailinHK (HK, str);
str:=LiesGeburtsortinHK (HK);
SetzeGeburtsortinHK (HK, str);
str:=LiesStaatsanginHK (HK);
SetzeStaatsanginHK (HK, str);
c:=LiesFamstandinHK (HK);
SetzeFamstandinHK (HK, c);
card:=LiesKinderinHK (HK);
SetzeKinderinHK (HK, card);
str:=LiesBankinstOrtinHK (HK);
SetzeBankinstOrtinHK (HK,str);
card:=LiesBlzinHK (HK);
SetzeBlzinHK (HK, card);
card:=LiesKontonrinHK (HK);
SetzeKontonrinHK (HK, card);
str:=LiesAbschlussinHK (HK);
SetzeAbschlussinHK (HK, str);
card:=LiesPersonalnrinHK (HK);
SetzePersonalnrinHK (HK, card);
str:=LiesBemerkungeninHK (HK);
SetzeBemerkungeninHK (HK, str);
card:=LiesPraestageinHK (HK);
SetzePraestageinHK (HK, card);
str:=LiesInteresseninHK (HK);
SetzeInteresseninHK (HK, str);
dat:=LiesVerfuegAbinHK (HK);
SetzeVerfuegAbinHK (HK, dat);
card:=LiesVorStdzahlinHK (HK);
SetzeVorStdzahlinHK (HK, card);
str:=PersIDAlsString (pers);
pers:=StringInPersID (str);
true:=ExistiertPersIDHK (HK);
pers:=LiesPersIDHK (HK);

true:=SearchHK(pers, HK);

strl:=GibHKeAlsStringlisteInHke();


(*
true:=AufnehmenHK (HK,str);
true:=LoeschenHK (HK, str);
true:=LoeschenHK (HK, str);
*)


END SysHK.
