IMPLEMENTATION MODULE FAnlegenHK;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc, TWinHdle;

FROM ProgArgs IMPORT GetArg;

FROM Types IMPORT SHORTCARD,LONGCARD;

FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;

FROM args IMPORT GetArgs, ArgTable;

IMPORT Strings;
IMPORT String;
IMPORT Stringliste;

(* ACHTUNG : Das Programm entfernt keine erzeugten Strings und
** Stringlisten. Die X-Grafik-Bibliothek kopiert alle Strings, so
** dass diese nach Erzeugung der Fenster geloescht werden koennten.
** Das Schliessen eines Fensters ueber die Window s-Menue-Leiste wird
** von der X-Grafik-Bibliothek nicht erkannt und ist verboten.
*)

  TYPE 	TFAnlegenDS = RECORD
		       WinHdle : ADDRESS;
		       Knopf1 : ADDRESS;
		       Knopf2 : ADDRESS		
		      END;	
       	TPFAnlegen = POINTER TO TFAnlegenDS;
        (* TProcCallb = PROCEDURE(); *)
	(* TProc = PROCEDURE (ADDRESS); *)
	(* TWinHdle = ADDRESS; *)
	


(* --------------------------------------------------------------- *)



PROCEDURE AktivFAnlegen();
  VAR
    StartKnopfText,
    EndeKnopfText       : String.TString;
    EndeKnopfHandle,
    StartKnopfHandle: ADDRESS;
    proc: TProc;
    WinAddr: TWinHdle;
    Fenster: TPFAnlegen;

  BEGIN
    (* Erzeuge den Fensterinhalt *)
    Top(proc, WinAddr);
    Fenster:= CAST(TPFAnlegen, WinAddr);
    EndeKnopfText := String.Create();
    String.Schreibe(EndeKnopfText,"Ende");
    EndeKnopfHandle := StelleKnopfDar(EndeKnopfText,Fenster^.WinHdle,10,10,CAST(PROC,EndeKnopfCallback));
    StartKnopfText := String.Create();
    String.Schreibe(StartKnopfText,"Fenster2");
    StartKnopfHandle := StelleKnopfDar(StartKnopfText,Fenster^.WinHdle,100,10,CAST(PROC,StartKnopfCallback));
    WITH Fenster^ DO
      Knopf1:= EndeKnopfHandle;
      Knopf2:= StartKnopfHandle;
    END (*WITH*)
  END AktivFAnlegen;



PROCEDURE EndeKnopfCallback();
  BEGIN
    DisposeFAnlegen();
  END EndeKnopfCallback;

PROCEDURE StartKnopfCallback();
  BEGIN
    DeaktFAnlegen();
    CreateFAnlegen();
  END StartKnopfCallback;

PROCEDURE CreateFAnlegen();
  VAR FensterUeberschrift: String.TString;
      WinHdle: TWinHdle;
      Fenster: TPFAnlegen;
      FensterAddr: TWinHdle;
  BEGIN
    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Anlegen einer Hilfskraft");
    WinHdle:=NeuesFenster(FensterUeberschrift,300,300,300,500);
    ALLOCATE (Fenster, TSIZE(TFAnlegenDS));
    Fenster^.WinHdle:=WinHdle;
    FensterAddr:= CAST(TWinHdle, Fenster);
    Push(ReaktFAnlegen, FensterAddr);
    AktivFAnlegen();
  END CreateFAnlegen;

PROCEDURE DisposeFAnlegen();
  VAR WinAddr: TWinHdle;
      proc: TProc;
      Fenster: TPFAnlegen;
  BEGIN
    Top(proc, WinAddr);
    Fenster:= CAST(TPFAnlegen, WinAddr);
    EntferneKnopf(Fenster^.Knopf1);
    EntferneKnopf(Fenster^.Knopf2);
    EntferneFenster(Fenster^.WinHdle);
    Pop();
    Top(proc, WinAddr);
    proc();
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR WinAddr: TWinHdle;
      proc: TProc;
      Fenster: TPFAnlegen;
  BEGIN
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(proc, WinAddr);
    Fenster:= CAST(TPFAnlegen, WinAddr);
    SetzeKnopf(Fenster^.Knopf1, FALSE);
    SetzeKnopf(Fenster^.Knopf2, FALSE);
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR WinAddr: TWinHdle;
      proc: TProc;
      ichSelbst: TPFAnlegen;

  BEGIN
   (* Aktiviere alle Fensterinhalte *)
   Top(proc, WinAddr);
   ichSelbst:= CAST(TPFAnlegen, WinAddr);
   SetzeKnopf(ichSelbst^.Knopf1, TRUE);
   SetzeKnopf(ichSelbst^.Knopf2, TRUE);
  END ReaktFAnlegen;


END FAnlegenHK.


