(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FSelBeKstT;

JZ

V 0.0   20.1.01  12:40
V 0.1   24.1.01  12:40


*)
(******************************************************************************)

IMPLEMENTATION MODULE FSelBeKstT;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM InOut IMPORT WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
IMPORT FBearbKstT;
(*
FROM Datum 	IMPORT 	TDatum, TTag, TMonat, TJahr, TStag, CreateDatum;
FROM Vtre	IMPORT 	TVtrID, TVtr;

FROM Buen IMPORT TBu, TBuID, CreateBu, DisposeBu, DuplicateBu, IsEqualBu,
		EqualizeBu, LiesBuIDinBu, LiesKstIDinBu, SetzeKstIDinBu,
		LiesVtrIDinBu, SetzeVtrIDinBu, LiesBetraginBu,
		SetzeBetraginBu, LiesGebuchtAminBu, SetzeGebuchtAminBu,
		LiesStorniertAminBu, SetzeStorniertAminBu, IstStorniertinBu,
		LiesBuchungsArtinBu, SetzeBuchungsArtinBu, BuIDAlsString,
		StringInBuID, PruefeBuID, ExistiertBuIDBu;


FROM Ksten IMPORT TKstID, TKst, CreateKst, SetzeKIDinKst, LiesKIDinKst,
 		SetzeEingAminKst, LiesEingAminKst, SetzeGesperrtAminKst,
 		LiesGesperrtAminKst,IstGesperrtAminKst,SetzeLiquidAminKst, 	
		LiesLiquidAminKst, IstLiquidiertAminKst, SetzeNameinKst,
		LiesNameinKst, SetzeJahrinKst,LiesJahrinKst, SetzeKontinginKst,
		LiesKontinginKst, SetzeAequivinKst, LiesAequivinKst,
		ExistKst, KstIDAlsString, StringInKstID, PruefeKstID,
		GibKstenAlsStringlisteInKsten, SearchKstZuKID;


FROM Konden IMPORT TKond, CreateVertragsKondition, CreateWeihnachtsKondition,
		CreateTarifkondition, DisposeKond, SetzeGueltVoninKond,
		LiesGueltVoninKond, SetzeGueltBisinKond, LiesGueltBisinKond,
		SetzeBHDinVKond, LiesBHDinVKond, SetzeSOGinVKond,
		LiesSOGinVKond, SetzeStdSinTKond, LiesStdSinTKond,
		SetzeSTaginWKond, LiesSTaginWKond, SetzeBemMonatinWKond,
		LiesBemMonatinWKond, HoleGueltigeVKond, HoleGueltigeTKond,
		HoleGueltigeWKond;


FROM PSB IMPORT	SperrenKst, EntsperrenKst, EinrichtenKst, BearbeitenBuchenKst,
                BearbeitenAendernKst, TKondGeprueftEinf, WKondGeprueftEinf, VKondGeprueftEinf;
*)





(* ACHTUNG : Das Programm entfernt keine erzeugten Strings und
** Stringlisten. Die X-Grafik-Bibliothek kopiert alle Strings, so
** dass diese nach Erzeugung der Fenster geloescht werden koennten.
** Das Schliessen eines Fensters ueber die Window s-Menue-Leiste wird
** von der X-Grafik-Bibliothek nicht erkannt und ist verboten.
*)

  TYPE 	TFSelektionBearbKstDS = RECORD
			XXX: ARRAY [1..100] OF CHAR;
		           WinHdle : ADDRESS;
		           ListenHdle : ADDRESS;
			   AbbrechenKnopfHdle:ADDRESS;  		
  	                   KstIDString: String.TString;
  	      		   FTyp:CHAR;
  	      		 END;	
        TPFSelektionBearbKst = POINTER TO TFSelektionBearbKstDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    I: CARDINAL;
    AnlegenKnopfText,
    LoeschenKnopfText,
    AbbrechenKnopfText     : String.TString;
    Ueberschrift: String.TString;
    Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSelektionBearbKst;
    KstStringListe: Stringliste.TStringliste;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);

    StelledarListe();

    AbbrechenKnopfText := String.Create();
    String.Schreibe(AbbrechenKnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(AbbrechenKnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(AbbrechenKnopfText);

    IF TRACE THEN WriteString("FSelektionBearbKst.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE StelledarListe();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    AnlegenKnopfText,
    LoeschenKnopfText,
    AbbrechenKnopfText     : String.TString;
    Ueberschrift: String.TString;
    Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSelektionBearbKst;
    KstStringListe: Stringliste.TStringliste;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.StelledarListe Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);


(*  KstStringListe:=GibKstenAlsStringlisteInKsten();
*)
    KstStringListe := Stringliste.Create();
    Listenelement := String.Create();
    String.Schreibe (Listenelement,"01585 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"12345 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"11111 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"22222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"32222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"42222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"52222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"62222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"72222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"82222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);

    Ueberschrift := String.Create();
    String.Schreibe (Ueberschrift, "Kostenstelle, Auswahl mit linker Maustaste");
    String.Schreibe (Ueberschrift, "KstID     N  a  m  e               Jahr  GesperrtAm");
    ichSelbst^.ListenHdle := StelleListeDar(KstStringListe,Ueberschrift,9,
                             ichSelbst^.WinHdle,50,40,CAST(PROC,ListeCallback));

    WHILE NOT (Stringliste.IsEmpty(KstStringListe)) DO
      Stringliste.GoStart(KstStringListe);
      Stringliste.Delete(KstStringListe);
    END;
    Stringliste.Dispose(KstStringListe);

    IF TRACE THEN WriteString("FSelektionBearbKst.StelledarListe End"); WriteLn; END;
  END StelledarListe;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.AbbrechenKnopfCallback Begin"); WriteLn; END;

    DisposeFAnlegen();

    IF TRACE THEN WriteString("FSelektionBearbKst.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE ListeCallback(Nr:INTEGER);
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, KontingentString,
						AequivalentString: String.TString;
    MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSelektionBearbKst;
    ElementString: String.TString;
    TextStr: ARRAY [1..100] OF CHAR;
    ElementStr: ARRAY [1..100] OF CHAR;

  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.ListeCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);

    ElementString := String.Create();
    LiesListenelement(ichSelbst^.ListenHdle, Nr, ElementString);
    String.Lies(ElementString, ElementStr);
    ichSelbst^.KstIDString:=String.Create();
    String.Auslesen(ElementString,0,5,ichSelbst^.KstIDString);
    MeldString := String.Create();
    String.Schreibe( MeldString,"Kst mit nachfolgender KstID wird bearbeitet:");
    String.Anhaengen(ichSelbst^.KstIDString, MeldString);
    String.Lies(MeldString, MeldStr);

(*  AusgebenMeldung(MeldStr);
    AusgebenMeldung(MeldStr);
*)

    (* Neues Fenster erzeugen *)
    DeaktFAnlegen();
    FBearbKstT.CreateFAnlegen(ichSelbst^.KstIDString);

    IF TRACE THEN WriteString("FSelektionBearbKst.ListeCallback End"); WriteLn; END;
  END ListeCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      ichSelbst: TPFSelektionBearbKst;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.CreateFAnlegen Begin"); WriteLn; END;

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Selektion der zu bearbeitenden Kostenstelle");
    ALLOCATE (ichSelbst, TSIZE(TFSelektionBearbKstDS));
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    ichSelbst^.FTyp:="2";
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);
    AktivFAnlegen();

    IF TRACE THEN WriteString("FSelektionBearbKst.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);
     IF NOT (ichSelbst^.FTyp = "2") THEN
      WriteString(" FSelektionBearbKst.FTyp falsch");
    END;
    IF ichSelbst^.WinHdle = NIL THEN
      WriteString(" FSelektionBearbKst.WinHdle ist NIL");
    END;
    IF ichSelbst^.ListenHdle = NIL THEN
      WriteString(" FSelektionBearbKst.ListenHdle ist NIL");
    END;
    IF ichSelbst^.AbbrechenKnopfHdle = NIL THEN
      WriteString(" FSelektionBearbKst.AbbrechenKnopfHdle ist NIL");
    END;

(*    EntferneListe(ichSelbst^.ListenHdle);     *)
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();

    IF TRACE THEN WriteString("FSelektionBearbKst.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.DeaktFAnlegen Begin"); WriteLn; END;

    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);
(*    SetzeListe(ichSelbst^.ListenHdle, FALSE);    shit gibt's net *)
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);

    EntferneListe(ichSelbst^.ListenHdle);


    IF TRACE THEN WriteString("FSelektionBearbKst.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBearbKst;
      Ueberschrift:String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.ReaktFAnlegen Begin"); WriteLn; END;

    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);


(* !!!!!!!!!!  Liste muss neu erstellt werden, damit Aenderungen angezeigt werden(gesperrt) *)
(*
    Ueberschrift := String.Create();
    String.Schreibe (Ueberschrift, "Kostenstelle, Auswahl mit linker Maustaste");
    String.Schreibe (Ueberschrift, "KstID     N  a  m  e               Jahr  GesperrtAm");
    ichSelbst^.ListenHdle := StelleListeDar(ichSelbst^.KstStringListe, Ueberschrift, 9,
		                             	ichSelbst^.WinHdle, 50, 40, CAST(PROC,ListeCallback));
*)

    StelledarListe();
            	
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);

    IF TRACE THEN WriteString("FSelektionBearbKst.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;







PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFSelektionBearbKst;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.AusgebenMeldung Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);

    IF TRACE THEN WriteString("FSelektionBearbKst.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;

PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;





CONST
  TRACE=FALSE;
VAR
BEGIN;
END FSelBeKstT.

