(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: BelBez.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:47:50 $
# $Revision: 1.1.1.1 $
# Bemerkungen: 

IMPELENTATION MODULE BelBez   FM BelastetBeziehung

Sigrid Preuss

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE BelBez;

(* FM BelastetBeziehung *)

  IMPORT Buen;
  IMPORT Ksten;
  FROM String IMPORT TString; 

(******************** An TS Buchungen TS_Buen durchgereichte Opeationen ******) 

PROCEDURE FirstBuZuKst (inKstID : TKstID; VAR outBu : TBu) : BOOLEAN;
(*
Vb:	 ExistiertBuID(inoutBu) AND Search(inoutBu.BuID,x)
Die erste nicht stornierte Buchung B mit B.KstID = inKstID wird zurueckgegeben und auf diese positioniert
Sei OK der boolsche Rueckgabewert, dann gilt:
Nb:     Ordner nicht leer <=> outBu enthaelt die erste nicht stornierte
        Buchung B mit B.KstID = inKstID
*)

   BEGIN
      RETURN Buen.FirstBuZuKst (inKstID, outBu);
   END FirstBuZuKst;



PROCEDURE NextBuZuKst  (inKstID : TKstID; inoutBu : TBu) : BOOLEAN;
(*
Vb:	 ExistiertBuID(inoutBu) AND Search(inoutBu.BuID,x)
Die naechste nicht stornierte Buchung B mit  B.KstID = inKstID wird zurueckgegeben und auf diese positioniert
Sei OK der boolsche Rueckgabewert, dann gilt:
Nb:	OK <=> inoutBu enthaelt die naechste nicht stornierte Buchung
               AND pos_neu = pos_alt + 1
*)
   BEGIN
      RETURN Buen.NextBuZuKst  (inKstID, inoutBu); 
   END NextBuZuKst;

  PROCEDURE BerGebGelderDerKst(inKstID: TKstID):INTEGER;
(* Vb:  keine 
Berechne gebuchte Gelder der Kostenstelle inKstID
Nb:     Rueckgabe der gebuchten Gelder zu der Kostenstelle inKstID 
*)
                    
  BEGIN
      RETURN Buen.BerGebGelderDerKst(inKstID);
  END BerGebGelderDerKst;

END BelBez. 	


