(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HKB.mod,v $
# $Author: Sopra $
# $Date: 2001/01/14 11:50:22 $
# $Revision: 1.26 $
Bemerkungen:
	Erstentwurf		: Gabi
	Implementation 		: Reini
	letzte Aenderung	: 02.03.2001
*)
(******************************************************************************)
 

IMPLEMENTATION MODULE HKB;

IMPORT HKVerw;
IMPORT VtrVerw;



(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
  PROCEDURE  BerRestEtatDerKst(inKstID : TKstID): INTEGER;
  BEGIN
	RETURN VtrVerw.BerRestEtatDerKst (inKstID)
  END BerRestEtatDerKst;


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE StornierenVtr (inVtr:TVtr; VAR outMessage:TString):BOOLEAN;
(* interne und externe Prozedur *)
(*  StornierungPruefen D 3.6.2.1 *)
  BEGIN
	
	RETURN VtrVerw.StornierenVtr ( inVtr, outMessage )

  END StornierenVtr; (*StornierenVtr*)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE BearbeitenNeuVtr ( inVtr: TVtr; VAR outMessage:TString): BOOLEAN;


  BEGIN
	RETURN VtrVerw.BearbeitenNeuVtr ( inVtr, outMessage )

  END BearbeitenNeuVtr; (*BearbeitenNeuVtr*)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE AendernVtr ( inVtr: TVtr; inEndeNeu:TDatum; VAR outMessage:TString):BOOLEAN;

(* beinhaltet VertragsendePruefen D 3.6.2.2 und
   verwendet u.a. BerechneBrutto und CreateBu mit Feldzuweisungen
   und InsertBu *)
  BEGIN

	RETURN VtrVerw.AendernVtr ( inVtr, inEndeNeu, outMessage )

  END AendernVtr;



(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


  PROCEDURE AufnehmenHK ( inHK : THK; VAR outMessage : TString) : BOOLEAN;
  BEGIN
(* Proze D 3.5.2 *)
(*   Vorbed.: HK nicht in Hilfskraefte
     Nachbed.: neue HK aufgenommen
 *)
	RETURN HKVerw.AufnehmenHK (inHK, outMessage)

  END AufnehmenHK; (* AufnehmenHK *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


  PROCEDURE AendernHK (  inNeuHK: THK; VAR outMessage: TString)  : BOOLEAN;
  BEGIN
	RETURN HKVerw.AendernHK ( inNeuHK, outMessage)
	
  END AendernHK; (* AendernHK *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE LoeschenHK ( inHK: THK; VAR outMessage:TString):BOOLEAN;
  BEGIN
   (* hier wird geprft, ob die HK berhaupt exisitert *)
	RETURN HKVerw.LoeschenHK ( inHK, outMessage )

  END LoeschenHK; (* LoeschenHK *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)



END HKB.






