(*345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50         60       70        80
*)

IMPLEMENTATION MODULE LogDatei;
   FROM  SeqFile IMPORT ChanId, FlagSet, old,
                        OpenWrite, Close, OpenResults;
   FROM  TextIO  IMPORT WriteString, WriteChar, WriteLn;
   FROM  IOChan  IMPORT Flush;


   CONST strbeg = "Begin HiKS";
         strend = "End HiKS";
         DateiNameLog  = "log";


   VAR   cidlog  : ChanId;
         openres : OpenResults;



PROCEDURE OpenLog();

BEGIN

  OpenWrite (cidlog, DateiNameLog, old, openres);

  WriteLn(cidlog);
  WriteString(cidlog, strbeg); WriteLn(cidlog); Flush(cidlog);

END OpenLog;


PROCEDURE CloseLog();

BEGIN

   WriteString(cidlog, strend); WriteLn(cidlog);
   Close(cidlog);
END CloseLog;


PROCEDURE WriteLogString(inString : ARRAY OF CHAR);

BEGIN
   WriteString(cidlog, inString); Flush(cidlog);
END WriteLogString;


PROCEDURE WriteLogChar(inChar : CHAR);

BEGIN
   WriteChar(cidlog, inChar); Flush(cidlog);
END WriteLogChar;



END LogDatei.
