
(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: PSBIM52.MOD,v $
# $Author: Sopra $ Gabi
# $Date: 2001/02/06
# $Revision: 1.1.1.1 $
Bemerkungen: 


*)
(******************************************************************************)
IMPLEMENTATION MODULE PSBIMPORTE;

(* Modul zur Bndelung der Importe des TS_PSB *)


IMPORT Datum;
IMPORT Buen;
IMPORT String;
IMPORT Vtre;
IMPORT Ksten;
IMPORT Konden;
(* auskommentiert bis HKB fertig  IMPORT HKB;*)
IMPORT SysDat;

(*
FROM Buen 	IMPORT TBu, InsertBu, LiesKstIDinBu, CreateBu, SetzeBetraginBu, SetzeBuchungsArtinBu, InsertBu;
FROM String 	IMPORT TString;
FROM Vtre       IMPORT FirstVtr, NextVtr, SearchKstZuKID;
FROM Ksten	IMPORT TKst, TKstID, LiesKIDinKst,SetzeKIDinKst, InsertKst,
			ExistKst, IstLiquidiertKst, SetzeGesperrtAminKst,
			IstGesperrtAminKst, AendernKst;
FROM Konden  	IMPORT LoescheWKondVorZeitp, LoescheTKondVorZeitp, LoescheTKondVorZeitp;
FROM HKB	IMPORT BerRestEtatDerKst;
*)

(****************************************************
        IMPORTE aus TS HKB
*****************************************************)
(* auskommentiert, bis HKB fertig PROCEDURE HBerRestEtatDerKst(inVtr: TVtr): INTEGER;
BEGIN
    RETURN HKB.BerRestEtatDerKst(inVtr);
END HBerRestEtatDerKst;           *)

(****************************************************
        IMPORTE aus TS HKe
*****************************************************)                     
 (****************************************************
        IMPORTE aus TS Vtre
*****************************************************)
PROCEDURE VFirstVtr(VAR outVtr : TVtr):BOOLEAN;
BEGIN
    RETURN Vtre.FirstVtr(outVtr);
END VFirstVtr;

PROCEDURE VNextVtr(inoutVtr : TVtr):BOOLEAN;
BEGIN
    RETURN Vtre.NextVtr(inoutVtr);
END VNextVtr;



(* muss die Funktion in Vtre realisiert werden oder im PSB ???????????
######################################################################
PROCEDURE VSearchKstZuKID( inKID: TKstID; VAR outKst : TKst):BOOLEAN;
BEGIN
     RETURN Vtre.SearchKstZuKID(inKID, outKst);
END VSearchKstZuKID;	
*)	

(****************************************************
        IMPORTE aus TS Ksten
*****************************************************)
          
                     
PROCEDURE KLiesKIDinKst ( inKst: TKst):TKstID;
BEGIN
    RETURN Ksten.LiesKIDinKst(inKst);
END KLiesKIDinKst ;


                     
PROCEDURE KSetzeKIDinKst (inK  : TKstID;  inoutKst: TKst);
BEGIN
    Ksten.SetzeKIDinKst(inK, inoutKst);
END KSetzeKIDinKst;


                     
PROCEDURE KInsertKst(inK:TKst;VAR outMessage:TString):BOOLEAN;
BEGIN
    RETURN Ksten.InsertKst(inK,outMessage);
END KInsertKst;


                     
PROCEDURE KExistKst(inKst: TKst):BOOLEAN;
BEGIN
    RETURN Ksten.ExistKst(inKst);
END KExistKst;


                     
PROCEDURE KIstLiquidiertAminKst ( inKst: TKst):BOOLEAN;
BEGIN
     RETURN Ksten.IstLiquidiertAminKst(inKst);
END KIstLiquidiertAminKst;

PROCEDURE KSetzeGesperrtAminKst (inoutKst:TKst; inD:TDatum);
BEGIN
	Ksten.SetzeGesperrtAminKst(inoutKst, inD);
END KSetzeGesperrtAminKst;

PROCEDURE KIstGesperrtAminKst ( inKst: TKst):BOOLEAN;
BEGIN
	RETURN TRUE;
END KIstGesperrtAminKst;




PROCEDURE KAendernKst (inKst: TKst; VAR outMessage : TString): BOOLEAN;
BEGIN
    RETURN Ksten.AendernKst(inKst, outMessage);
END KAendernKst;



(****************************************************
        IMPORTE aus TS Datum
*****************************************************)

PROCEDURE DLiefereDatumEternity(VAR inoutD:TDatum);
BEGIN
    Datum.SetzeDatumEternity(inoutD);
END DLiefereDatumEternity;

PROCEDURE DIstDatumEternity(D: TDatum): BOOLEAN;
BEGIN
    RETURN Datum.IstDatumEternity(D);
END DIstDatumEternity;


(****************************************************
        IMPORTE aus TS Konden
*****************************************************)

PROCEDURE KLoescheWKondVorZeitp(inGueltigVon:TDatum; VAR outMessage:TString):BOOLEAN;
BEGIN
    RETURN Konden.LoescheWKondVorZeitp(inGueltigVon, outMessage);
END KLoescheWKondVorZeitp;

                     
PROCEDURE  KLoescheTKondVorZeitp(inGueltigVon : TDatum; VAR outMessage : TString) : BOOLEAN;
BEGIN
     RETURN Konden.LoescheTKondVorZeitp(inGueltigVon, outMessage);
END KLoescheTKondVorZeitp;

                     
PROCEDURE  KLoescheVKondVorZeitp(inGueltigVon : TDatum; VAR outMessage : TString) : BOOLEAN;
BEGIN
     RETURN Konden.LoescheVKondVorZeitp(inGueltigVon, outMessage);
END KLoescheVKondVorZeitp;

(****************************************************
        IMPORTE aus TS Buen
*****************************************************)


                     
PROCEDURE BInsertBu(inBu:TBu;  VAR outMessage : TString) : BOOLEAN;
BEGIN
    RETURN Buen.InsertBu(inBu, outMessage);
END BInsertBu;


PROCEDURE BLiesKstIDinBu (inBu:TBu):TKstID;
BEGIN
    RETURN Buen.LiesKstIDinBu(inBu);
END BLiesKstIDinBu;

PROCEDURE BCreateBu():TBu;
BEGIN
    RETURN Buen.CreateBu();
END BCreateBu;

PROCEDURE BSetzeBetraginBu(inoutB: TBu; Betrag:INTEGER);
BEGIN
    Buen.SetzeBetraginBu(inoutB, Betrag);
END BSetzeBetraginBu;
			

PROCEDURE BSetzeBuchungsArtinBu(inoutB: TBu; BArt: TString);
BEGIN
	Buen.SetzeBuchungsArtinBu(inoutB, BArt);
END BSetzeBuchungsArtinBu;


PROCEDURE BSetzeKstIDinBu(inoutBu:TBu; inKstID:TKstID);
BEGIN
    	Buen.SetzeKstIDinBu(inoutBu, inKstID);
END BSetzeKstIDinBu;

(****************************************************
        IMPORTE aus TS SysDat
*****************************************************)
PROCEDURE SLiesSystemDatumInSysDat(): TDatum;
BEGIN
   	RETURN SysDat.LiesSystemDatumInSysDat();
END SLiesSystemDatumInSysDat;

(****************************************************
        IMPORTE aus FM HatBuBez
*****************************************************)
(****************************************************
        IMPORTE aus FM BelBez
*****************************************************)
(****************************************************
        IMPORTE aus FM VtrBez
*****************************************************)


END PSBIMPORTE.
