(* Fernuni Hagen Sopra WS2000/01    Autor: Christian Sonnweber *)

IMPLEMENTATION MODULE FSichernSysVw;

FROM SYSTEM   IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;
FROM SYSTEM   IMPORT CAST, ADR, ADDRESS;
FROM args     IMPORT GetArgs, ArgTable;
FROM InOut    IMPORT WriteString,WriteLn,WriteInt;

IMPORT Datum;
IMPORT SysDat;
IMPORT Adm;
IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT FSichernSysVw;


TYPE TActVater   = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;

VAR
  FensterHandle	   : ADDRESS;
  VaterFenster	   : ADDRESS;
  Vater		   : ADDRESS;
  InitDatListe     : ADDRESS;
  EndeKnopfHandle  : ADDRESS;
  VersMeldHandle1  : ADDRESS;
  VersMeldHandle2  : ADDRESS;
  EingZeileHdle    : ADDRESS;
  HelpMeldHdle1    : ADDRESS;
  StartKnopfHdle   : ADDRESS;
  ShowSysDatListe  : ADDRESS;
  ShowSysDatKnopf  : ADDRESS;
  SysFenVisible    : BOOLEAN;
(*----------------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;

BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowSysDat();
VAR  Titel         :  String.TString;
     s             :  String.TString;
     s1		   :  String.TString;
     str1          :  String.TString;
     str2          :  String.TString;
     str3          :  String.TString;
     VersString    :  String.TString;
     Date          :  Datum.TDatum;
     Vers	   :  SysDat.TVersion;
     Vers1	   :  SysDat.TVersion;
     StrListe      :  Stringliste.TStringliste;
BEGIN
   StrListe      :=  Stringliste.Create();
   s		 :=  String.Create();
   s1		 :=  String.Create();
   str1          :=  String.Create();
   str2          :=  String.Create();
   str3          :=  String.Create();
   VersString    :=  String.Create();

(*SysDat - Daten einlesen*)
(* ############################################################################################### *)
   Vers1 := SysDat.LiesBackupVersionInSysDat();
   s := SysDat.VersionAlsString(Vers1);
   WriteString("Versionszhler:  "); WriteString(StC(s));WriteLn();
   String.Schreibe(s1,"VersZaehler:  ");
   String.Anhaengen(s,s1);
(* ############################################################################################### *)


  IF SysDat.FirstBackupInSysDat(Vers,Date) THEN
     (* Erzeuge das Format: "1  12.02.53" fr die anschlieende Ausgabe in der Liste *)
     Stringliste.Insert(StrListe,ErzeugeAktVersionAlsString(Vers,Date));
     WHILE SysDat.NextBackupInSysDat(Vers,Date) DO
       Stringliste.Insert(StrListe,ErzeugeAktVersionAlsString(Vers,Date));
     END;
   END;

   Date  := SysDat.LiesSystemDatumInSysDat();
   String.Schreibe(s1,StC(Datum.DatumAlsString(Date)));
   String.Schreibe(s,"SystemDatum:         ");
   String.Anhaengen(s1,s);
   Stringliste.Insert(StrListe,s);

   Date  := SysDat.LiesLetztesAutoDatumInSysDat();
   String.Schreibe(s1,StC(Datum.DatumAlsString(Date)));
   String.Schreibe(s,"LetzterAutoBetrieb:  ");
   String.Anhaengen(s1,s);
   Stringliste.Insert(StrListe,s);


(*SysDat - Daten einlesen*)
(* ############################################################################################### *)
   Vers1 := SysDat.LiesBackupVersionInSysDat();
   s := SysDat.VersionAlsString(Vers1);
   WriteString("Versionszhler:  "); WriteString(StC(s));WriteLn();
   String.Schreibe(s1,"VersZaehler:  ");
   String.Anhaengen(s,s1);
   Stringliste.Insert(StrListe,s1);
(* ############################################################################################### *)

   String.Schreibe(s," SysDat-Info");

   ShowSysDatListe := StelleListeDar(StrListe,s,12,FensterHandle,30,20,CAST(PROC,SysDatListeCallback));

   String.Dispose(s);
   String.Dispose(s1);
   String.Dispose(str1);
   String.Dispose(str2);
   String.Dispose(str3);
   String.Dispose(VersString);
   Stringliste.Dispose(StrListe);

END ShowSysDat;
(*----------------------------------------------------------------------------------------*)

PROCEDURE SysDatListeCallback();
BEGIN
END SysDatListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeKnoepfe();
VAR Titel : String.TString;
BEGIN
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,450,260,CAST(PROC,EndeKnopfCallback));
  String.Schreibe(Titel,"SysDat-Info");
  ShowSysDatKnopf := StelleKnopfDar(Titel,FensterHandle,300,260,CAST(PROC,ShowSysDatKnopfCallback));
  String.Dispose(Titel);
END ErzeugeKnoepfe;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
BEGIN
  Dispose();
END EndeKnopfCallback;
(*----------------------------------------------------------------------------------------*)


PROCEDURE ShowSysDatKnopfCallback();
BEGIN
  IF NOT SysFenVisible THEN
   ShowSysDat();
  ELSE
   EntferneListe(ShowSysDatListe);
  END;
  SysFenVisible := NOT SysFenVisible;
END ShowSysDatKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE InitDatListeCallback();
VAR Titel : String.TString;
BEGIN

END InitDatListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EingabeMaskeErstellen();
VAR Titel : String.TString;
    Text  : String.TString;
BEGIN
 Titel := String.Create();
 String.Schreibe(Titel,"Version eingeben");
 Text := String.Create();
 String.Schreibe(Text,">> B a c k u p   S t a r t e n  >>");
 StartKnopfHdle := StelleKnopfDar(Text,FensterHandle,320,140,CAST(PROC,StartBackupCallback));
 String.Dispose(Titel);
 String.Dispose(Text);
 ShowSysDat();
END EingabeMaskeErstellen;

(*----------------------------------------------------------------------------------------*)

PROCEDURE StartBackupCallback();
VAR Titel  		: String.TString;
    errmsg		: String.TString;
    Abfragetext : String.TString;
    ok			: BOOLEAN;

BEGIN
  EntferneListe(InitDatListe);
  Titel := String.Create();
  EntferneMeldung(HelpMeldHdle1);
  EntferneMeldung(HelpMeldHdle1);
  EntferneZeile(EingZeileHdle);
  EntferneKnopf(StartKnopfHdle);

  ok := Adm.BackupSystemInAdm(errmsg);

  IF ok THEN
    String.Schreibe(Titel,"Backup erfolgreich durchgefhrt ");
    VersMeldHandle1 :=  StelleMeldungDar(Titel,TRUE,FensterHandle,300,110);
    (* "BAckup mit der VErsion....erfolggreich abgelett*)
  ELSE
    VersMeldHandle1 :=  StelleMeldungDar(errmsg,TRUE,FensterHandle,185,120);
    MeldungAnzeigen(errmsg);
    String.Dispose(errmsg);
  END;
 String.Dispose(Titel);
END StartBackupCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeAktVersionAlsString(inVers : SysDat.TVersion;inDatum : Datum.TDatum):String.TString;
(*
Erzeugt einen String.TString bestehend Inhalten von inVers plus inDatum
*)
VAR str1	: String.TString;
    str2	: String.TString;
    str3	: String.TString;

BEGIN
   str1 :=  String.Create();
   str2 :=  String.Create();
   str3 :=  String.Create();
   str1 := SysDat.VersionAlsString(inVers);
   str2 := Datum.DatumAlsString(inDatum);
   (* Erzeuge das Format: "1  12.02.53" fr die anschlieende Ausgabe in der Liste *)
   String.Schreibe(str3,"  ");
   String.Anhaengen(str3,str1);
   String.Anhaengen(str2,str1);
   (* Aufrumen*)
   String.Dispose(str2);
   String.Dispose(str3);
   RETURN str1;
END ErzeugeAktVersionAlsString;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel : String.TString;
BEGIN
  Vater := inFunct;
  Titel := String.Create();
  SysFenVisible := TRUE;
  String.Schreibe(Titel,"hiks.Systemverwaltung.SystemSpeichern");
  FensterHandle :=  NeuesFenster( Titel,170,170,350,600);
  String.Dispose(Titel);
  ErzeugeKnoepfe();
  EingabeMaskeErstellen();
END Create;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
  EntferneFenster(FensterHandle);
  AktiviereVater := CAST(TActVater,Vater);
  AktiviereVater();
END Dispose;
(*----------------------------------------------------------------------------------------*)

END FSichernSysVw.