IMPLEMENTATION MODULE FLadenSysVw;

FROM SYSTEM    IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik  IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik  IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik  IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik  IMPORT StelleTextDar, EntferneText;
FROM X_Grafik  IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik  IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik  IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik  IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik  IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik  IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik  IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik  IMPORT LiesMenueEintrag, EntferneMenue;
FROM SYSTEM    IMPORT CAST, ADR, ADDRESS;
FROM args      IMPORT GetArgs, ArgTable;
FROM InOut     IMPORT WriteString,WriteLn,WriteInt;
FROM DialogLib IMPORT DatumKorrekt;

IMPORT Datum;
IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT FLadenSysVw;
IMPORT Adm;
IMPORT SysDat;

TYPE TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;
VAR
  FensterHandle		: ADDRESS;
  VaterFenster		: ADDRESS;
  Vater			: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  VersionListe		: ADDRESS;
  DatumFeldHandle	: ADDRESS;
  DatEingHelpMeldung	: ADDRESS;
  AutoBetrKnopfHandle   : ADDRESS;
  DatOkKnopfHandle	: ADDRESS;
  DatumMeldHdle   	: ADDRESS;
  MeldHandle1     	: ADDRESS;
  Meldung1		: ADDRESS;
  VersMeldHandle1 	: ADDRESS;
  VersMeldHandle2 	: ADDRESS;
  LadFertMeldHdle 	: ADDRESS;
  UpsMeldung      	: ADDRESS;
  ShowSysDatListe   	: ADDRESS;
  ShowSysDatKnopf   	: ADDRESS;
  ProblemMeld		: ADDRESS;
  NewBackup	    	: BOOLEAN;
  SysFenVisible     	: BOOLEAN;
  LadenNegativMeldHdle : ADDRESS;
          (*DatumEingabeCallback*)
  Titel 		:   String.TString;
  TextVonEingabe 	:   String.TString;
  errmessg		:   String.TString;
  ups	  		:   String.TString;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowSysDat();

VAR  Titel : String.TString;
     s             :  String.TString;
     s1						 :  String.TString;
     str1          :  String.TString;
     str2          :  String.TString;
     str3          :  String.TString;
     VersString    :  String.TString;
     Date          :  Datum.TDatum;
     Vers          :  SysDat.TVersion;
     Vers1				 :  SysDat.TVersion;
     StrListe      :  Stringliste.TStringliste;
BEGIN
   StrListe      :=  Stringliste.Create();
   s		 :=  String.Create();
   s1   	 :=  String.Create();
   str1          :=  String.Create();
   str2          :=  String.Create();
   str3          :=  String.Create();
   VersString    :=  String.Create();
   (*SysDat - Daten einlesen*)
   Vers1 := SysDat.LiesBackupVersionInSysDat();
   String.Schreibe(s,StC(SysDat.VersionAlsString(Vers1)));
   String.Schreibe(s1,"VersZaehler:  ");
   String.Anhaengen(s,s1);

   IF SysDat.FirstBackupInSysDat(Vers,Date) THEN
      (* Erzeuge das Format: "1  12.02.53" fr die anschlieende Ausgabe in der Liste *)
     Stringliste.Insert(StrListe,ErzeugeAktVersionAlsString(Vers,Date));
     WHILE SysDat.NextBackupInSysDat(Vers,Date) DO
       Stringliste.Insert(StrListe,ErzeugeAktVersionAlsString(Vers,Date));
     END;
   END;

   Date  := SysDat.LiesSystemDatumInSysDat();
   String.Schreibe(s1,StC(Datum.DatumAlsString(Date)));
   String.Schreibe(s," SystemDatum:  ");
   String.Anhaengen(s1,s);
   Stringliste.Insert(StrListe,s);

   Date  := SysDat.LiesLetztesAutoDatumInSysDat();
   String.Schreibe(s1,StC(Datum.DatumAlsString(Date)));
   String.Schreibe(s," Letzter AutoBetrieb:  ");
   String.Anhaengen(s1,s);
   Stringliste.Insert(StrListe,s);

   Vers1 := SysDat.LiesBackupVersionInSysDat();
   String.Schreibe(s1,StC(SysDat.VersionAlsString(Vers)));
   String.Schreibe(s," VersZaehler:  ");
   String.Anhaengen(s1,s);
   Stringliste.Insert(StrListe,s);

   String.Schreibe(s," SysDat-Info");

   ShowSysDatListe := StelleListeDar(StrListe,s,4,FensterHandle,20,250,CAST(PROC,SysDatListeCallback));

   String.Dispose(s);
   String.Dispose(s1);
   String.Dispose(str1);
   String.Dispose(str2);
   String.Dispose(str3);
   String.Dispose(VersString);
   Stringliste.Dispose(StrListe);

END ShowSysDat;

(*----------------------------------------------------------------------------------------*)
PROCEDURE SysDatListeCallback();
BEGIN
END SysDatListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeKnoepfe();
VAR Titel : String.TString;
BEGIN
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,450,290,CAST(PROC,EndeKnopfCallback));
  String.Schreibe(Titel,"SysDat-Info");
  ShowSysDatKnopf := StelleKnopfDar(Titel,FensterHandle,300,290,CAST(PROC,ShowSysDatKnopfCallback));
  String.Dispose(Titel);
END ErzeugeKnoepfe;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowSysDatKnopfCallback();
BEGIN
  IF NOT SysFenVisible THEN
   ShowSysDat();
  ELSE
   EntferneListe(ShowSysDatListe);
  END;

  SysFenVisible := NOT SysFenVisible;

END ShowSysDatKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
VAR    AktiviereVater : TActVater;
BEGIN
  WriteString("EndeKnopfCallback");WriteLn();
  EntferneFenster(FensterHandle);
  WriteString("EndeKnopfCallback.EntferneFenster");WriteLn();
  AktiviereVater := CAST(TActVater,Vater);    (*Casting von ADDRESS nach TActVater. TActVater ist paremterlose Funktion*)
  WriteString("EndeKnopfCallback.AktiviereVater");WriteLn();
  AktiviereVater();                           (* Reaktiviere das Hauptfenster *)
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowVersions();
VAR  StrListe      :  Stringliste.TStringliste;
     s             :  String.TString;
     str1          :  String.TString;
     str2          :  String.TString;
     str3          :  String.TString;
     VersString    :  String.TString;
     Date          :  Datum.TDatum;
     Vers	   :  SysDat.TVersion;
BEGIN
   StrListe      :=  Stringliste.Create();
   s		 :=  String.Create();
   str1          :=  String.Create();
   str2          :=  String.Create();
   str3          :=  String.Create();
   VersString    :=  String.Create();

   (*SysDat - Daten einlesen*)
   IF SysDat.FirstBackupInSysDat(Vers,Date) THEN
      (* Erzeuge das Format: "1  12.02.53" fr die anschlieende Ausgabe in der Liste *)
     Stringliste.Insert(StrListe,ErzeugeAktVersionAlsString(Vers,Date));
     WHILE SysDat.NextBackupInSysDat(Vers,Date) DO
       Stringliste.Insert(StrListe,ErzeugeAktVersionAlsString(Vers,Date));
     END;
   END;
   String.Schreibe(s,"Ver.  Datum  ");
   VersionListe := StelleListeDar(StrListe,s,4,FensterHandle,10,30,CAST(PROC,VersionListeCallback));
               (* Aufrumen *)
   String.Dispose(s);
   String.Dispose(str1);
   String.Dispose(str2);
   String.Dispose(str3);
   String.Dispose(VersString);
   Stringliste.Dispose(StrListe);
END ShowVersions;
(*----------------------------------------------------------------------------------------*)

PROCEDURE VersionListeCallback(element : INTEGER);
VAR Titel   : String.TString;
    outText : String.TString;
    Ziel    : String.TString;
    err     : String.TString;
    tests   : String.TString;
    Ver     : SysDat.TVersion;
    success : BOOLEAN;

BEGIN
  success := FALSE;
  Titel   := String.Create();
  outText := String.Create();
  Ziel    := String.Create();
  err     := NIL;
  (*err     := String.Create(); *)
  (*Ver     := SysDat.CreateVersionInSysDat();*)

  (* Das ausgewhlte Listenelement einlesen und die Version bestimmen *)
  LiesListenelement(VersionListe,element,outText);
  String.Auslesen(outText,1,3,Ziel);
  WriteString("FLadenSysVw.VersionListeCallback: gewhlte Version: ");
  WriteString(StC(outText));WriteLn();
  EntferneListe(VersionListe);



  IF SysDat.VersionVonString (Ziel,Ver,err) THEN
    Titel := String.Create();
    String.Schreibe(Titel, " Version");
  	WriteString(StC(Ziel));WriteLn();
  	ProblemMeld     :=  StelleMeldungDar(Titel,TRUE,FensterHandle,230,30);
  	VersMeldHandle2 :=  StelleMeldungDar(outText,FALSE,FensterHandle,220,45);
  ELSE
   WriteString(StC(err));WriteLn;
  END;
  IF NOT(err = NIL) THEN
    String.Dispose(err);
    err := NIL;
  END;

  (*Einlesen der Dateien *)
  success :=  Adm.InitSystemInAdm(Ver,err);
  (*Konselenmeldung*)
  WriteString("FLadenSysVw.VersionListeCallback: ");
  WriteString(StC(err));WriteLn();
  (*Felhlermeldung Grabo*)
  (* Aufrumen *)
  IF err <> NIL THEN
    String.Dispose(err);
  END;

  IF NOT success THEN
    LadenNegativMeldHdle := StelleMeldungDar(err,TRUE,FensterHandle,230,130);
  ELSE
    (* Datumsbernahmeknopfhandle anlegen*)
    String.Schreibe(Titel,"--> Datum besttigen");
    DatOkKnopfHandle := StelleKnopfDar(Titel,FensterHandle,370,120,CAST(PROC,DatumEingabeCallback));
  END;


  String.Dispose(outText);
  String.Dispose(Ziel);
  SysDat.DisposeVersionInSysDat(Ver);

END VersionListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE InitialDialog();
VAR Titel  : String.TString;
    Text   : String.TString;
    ErrMsg : String.TString;
BEGIN
   Titel  := String.Create();
   Text   := String.Create();
   ErrMsg := String.Create();

   IF Adm.ReadIniDatei(ErrMsg) THEN
    WriteString("FLadenSysVw: SysDat.ini erfolgreich geladen");
    WriteLn;
                      (*SysDat als Liste darstellen*)
    ShowVersions();
   ELSE
                      (* Fehlermeldung !!! Adm.ReadIniDatei strzt ab *)
    WriteString(StC(ErrMsg));
    WriteLn;
   END;

   String.Schreibe(Titel,"Datum : ");
   Text := String.Create();
   String.Schreibe(Text,"");
   DatumFeldHandle := StelleZeileDar(Titel,Text,10,FensterHandle,180,120);

   String.Dispose(Titel);
   String.Dispose(Text);
   String.Dispose(ErrMsg);
END InitialDialog;


(*----------------------------------------------------------------------------------------*)

PROCEDURE MaskeDatumEingabe();
VAR Titel,Text : String.TString;
    TestZeile  : ADDRESS;
BEGIN
   Titel := String.Create();
   Text  := String.Create();

   String.Schreibe(Titel,"Datum : ");
   Text := String.Create();
   String.Schreibe(Text,"");
   TestZeile := StelleZeileDar(Titel,Text,10,FensterHandle,150,170);
  (* DatumFeldHandle := StelleZeileDar(Titel,Text,10,FensterHandle,150,170);*)

   String.Schreibe(Titel,"--> Datum besttigen");
   DatOkKnopfHandle := StelleKnopfDar(Titel,FensterHandle,380,170,CAST(PROC,DatumEingabeCallback));
   String.Dispose(Titel);
   String.Dispose(Text);
END MaskeDatumEingabe;

(*----------------------------------------------------------------------------------------*)

PROCEDURE DatumEingabeCallback();

VAR
    ok     : BOOLEAN;
    ok1    : BOOLEAN;
    dat	   : Datum.TDatum;
    error  : String.TString;
    str1   : String.TString;
    stg2   : String.TString;
    datstr : String.TString;
    vers   : SysDat.TVersion;
BEGIN
  WriteString("DatumEingabeCallback()");WriteLn();
  ok  := FALSE;
  ok1 := FALSE;
  dat := NIL;
  datstr := String.Create();
  dat    := Datum.CreateDatum();
  vers   := SysDat.CreateVersionInSysDat();

  (*Datum aus Dialog einlesen *)
  LiesZeile(DatumFeldHandle,datstr);

  (* Prfe die Korrektheit des Datumformates*)
  ok1 := DatumKorrekt(datstr,errmessg);
  IF ok1 THEN
   ok :=  Datum.DatumVonString ( datstr, dat, error );
   IF ok  THEN
    (* speichere Datum in SysDat + enferne Fehlermeldung + Stelle neue Maske dar*)
     WriteString("DatumEingabeCallback().IF ok1 ==>Daum ist korrekt");WriteLn();

     SysDat.SetzeSystemDatumInSysDat(dat);
     WriteString("DatumEingabeCallback().SysDat.SetzeSystemDatumInSysDat(dat)");WriteLn();;

    (*Fensterelemente entfernen*)
    EntferneKnopf(DatOkKnopfHandle);
    IF NOT(UpsMeldung=NIL) THEN
     EntferneMeldung(UpsMeldung);
     UpsMeldung := NIL;
    END;
    WriteString("DatumEingabeCallback().Fensterelemente entfernt");WriteLn();

    Titel := String.Create();
    String.Schreibe(Titel,"System erfolgreich geladen");
    LadFertMeldHdle := StelleMeldungDar(Titel,TRUE,FensterHandle,180,160);
    (* !!! Automatikbetrieb starten falls NOT(NewBackup) *)
    String.Schreibe(Titel,">>  Automatikbetrieb Starten  <<");
    AutoBetrKnopfHandle := StelleKnopfDar(Titel,FensterHandle,165,200,CAST(PROC,AutBetrKnHdleCallback));
    SysDat.DisposeVersionInSysDat(vers);
  END;
 END;

 IF NOT(ok AND ok1) THEN
   IF NOT(UpsMeldung=NIL) THEN
     EntferneMeldung(UpsMeldung);
     UpsMeldung := NIL;
   END;
   ups := String.Create();
   String.Schreibe(ups,"OUUPS!!!");
   UpsMeldung := StelleMeldungDar(ups,TRUE,FensterHandle,250,91);
 END;

                                           (* Aufrumen *)
 IF ok AND ok1 THEN
  IF NOT (Titel = NIL) THEN
    String.Dispose(Titel);
    Titel := NIL;
  END;

  IF NOT(UpsMeldung=NIL) THEN
    EntferneMeldung(UpsMeldung);
    UpsMeldung := NIL;
  END;

  IF NOT(datstr=NIL) THEN
    String.Dispose(datstr);
    datstr:=NIL;
  END;
 END;
 NewBackup := FALSE;
 SysDat.DisposeVersionInSysDat(vers);
END DatumEingabeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeAktVersionAlsString(inVers : SysDat.TVersion;inDatum : Datum.TDatum):String.TString;
(*
Erzeugt einen String.TString bestehend Inhalten von inVers plus inDatum
*)
VAR str1	: String.TString;
    str2	: String.TString;
    str3	: String.TString;
BEGIN
   str1 :=  String.Create();
   str2 :=  String.Create();
   str3 :=  String.Create();
   str1 := SysDat.VersionAlsString(inVers);
   str2 := Datum.DatumAlsString(inDatum);
   (* Erzeuge das Format: "1  12.02.53" fr die anschlieende Ausgabe in der Liste *)
   String.Schreibe(str3,"  ");
   String.Anhaengen(str3,str1);
   String.Anhaengen(str2,str1);
   (* Aufrumen*)
   String.Dispose(str2);
   String.Dispose(str3);
   RETURN str1;
END ErzeugeAktVersionAlsString;
(*----------------------------------------------------------------------------------------*)

PROCEDURE AutBetrKnHdleCallback;
VAR Titel : String.TString;
BEGIN
  EntferneKnopf(AutoBetrKnopfHandle);
  (*
  EntferneMeldung(MeldHandle1);
  EntferneMeldung(VersMeldHandle2);
  EntferneMeldung(VersMeldHandle1);
  EntferneMeldung(DatumMeldHdle);
  EntferneMeldung(LadFertMeldHdle);
  *)
  Titel := String.Create();
  String.Schreibe(Titel,"Autobetrieb beendet");
  Meldung1 := StelleMeldungDar(Titel,TRUE,FensterHandle,195,220);
  String.Dispose(Titel);
  EntferneMeldung(VersMeldHandle1);
END AutBetrKnHdleCallback;

(*------------------------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel : String.TString;

BEGIN
  InitializeVars();
  WriteString("FLadenSysVw.Create()"); WriteLn();
  Vater := inFunct;
  Titel := String.Create();
  String.Schreibe(Titel,"hiks.Systemverwaltung.SystemLaden");
  FensterHandle :=  NeuesFenster( Titel,170,160,380,630);
  ErzeugeKnoepfe();
  InitialDialog();
  String.Dispose(Titel);
END Create;

(*------------------------------------------------------------------------------------------*)
PROCEDURE InitializeVars();
BEGIN
  FensterHandle	:= NIL;
  VaterFenster		:= NIL;
  Vater			:= NIL;
  EndeKnopfHandle	:= NIL;
  VersionListe		:= NIL;
  DatumFeldHandle	:= NIL;
  DatEingHelpMeldung	:= NIL;
  AutoBetrKnopfHandle   := NIL;
  DatOkKnopfHandle	:= NIL;
  DatumMeldHdle   	:= NIL;
  MeldHandle1     	:= NIL;
  Meldung1		:= NIL;
  VersMeldHandle1 	:= NIL;
  VersMeldHandle2 	:= NIL;
  LadFertMeldHdle 	:= NIL;
  UpsMeldung      	:= NIL;
  ShowSysDatListe   	:= NIL;
  ShowSysDatKnopf   	:= NIL;
  NewBackup	    	:= FALSE;
  SysFenVisible     	:= FALSE;
 (*Initialisiere Variablen vom Typ TString *)
  Titel 		:= NIL;
  TextVonEingabe 	:= NIL;
  errmessg		:= NIL;
  ups	  		:= NIL;
END InitializeVars;
(*------------------------------------------------------------------------------------------*)
PROCEDURE Delay();
(* Versuch, Instabilitten des X-Systems abzufangen*)
VAR zaehler : INTEGER;
BEGIN
    WriteString("Delay");WriteLn();
END Delay;
(*------------------------------------------------------------------------------------------*)

END FLadenSysVw.
