(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FBearbKstT;

JZ

V 0.0   23.1.01  21:40
V 0.1   24.1.01  21:40

????????? Uebergebene Texte loeschen ?????
*)
(******************************************************************************)

IMPLEMENTATION MODULE FBearbKstT;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM InOut IMPORT WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;



(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
(*
FROM Datum 	IMPORT 	TDatum, TTag, TMonat, TJahr, TStag, CreateDatum;
FROM Vtre	IMPORT 	TVtrID, TVtr;

FROM Buen IMPORT TBu, TBuID, CreateBu, DisposeBu, DuplicateBu, IsEqualBu,
		EqualizeBu, LiesBuIDinBu, LiesKstIDinBu, SetzeKstIDinBu,
		LiesVtrIDinBu, SetzeVtrIDinBu, LiesBetraginBu,
		SetzeBetraginBu, LiesGebuchtAminBu, SetzeGebuchtAminBu,
		LiesStorniertAminBu, SetzeStorniertAminBu, IstStorniertinBu,
		LiesBuchungsArtinBu, SetzeBuchungsArtinBu, BuIDAlsString,
		StringInBuID, PruefeBuID, ExistiertBuIDBu;


FROM Ksten IMPORT TKstID, TKst, CreateKst, SetzeKIDinKst, LiesKIDinKst,
 		SetzeEingAminKst, LiesEingAminKst, SetzeGesperrtAminKst,
 		LiesGesperrtAminKst,IstGesperrtAminKst,SetzeLiquidAminKst, 	
		LiesLiquidAminKst, IstLiquidiertAminKst, SetzeNameinKst,
		LiesNameinKst, SetzeJahrinKst,LiesJahrinKst, SetzeKontinginKst,
		LiesKontinginKst, SetzeAequivinKst, LiesAequivinKst,
		ExistKst, KstIDAlsString, StringInKstID, PruefeKstID,
		GibKstenAlsStringlisteInKsten, SearchKstZuKID;


FROM Konden IMPORT TKond, CreateVertragsKondition, CreateWeihnachtsKondition,
		CreateTarifkondition, DisposeKond, SetzeGueltVoninKond,
		LiesGueltVoninKond, SetzeGueltBisinKond, LiesGueltBisinKond,
		SetzeBHDinVKond, LiesBHDinVKond, SetzeSOGinVKond,
		LiesSOGinVKond, SetzeStdSinTKond, LiesStdSinTKond,
		SetzeSTaginWKond, LiesSTaginWKond, SetzeBemMonatinWKond,
		LiesBemMonatinWKond, HoleGueltigeVKond, HoleGueltigeTKond,
		HoleGueltigeWKond;


FROM PSB IMPORT	SperrenKst, EntsperrenKst, EinrichtenKst, BearbeitenBuchenKst,
                BearbeitenAendernKst, TKondGeprueftEinf, WKondGeprueftEinf, VKondGeprueftEinf;
*)





(* ACHTUNG : Das Programm entfernt keine erzeugten Strings und
** Stringlisten. Die X-Grafik-Bibliothek kopiert alle Strings, so
** dass diese nach Erzeugung der Fenster geloescht werden koennten.
** Das Schliessen eines Fensters ueber die Window s-Menue-Leiste wird
** von der X-Grafik-Bibliothek nicht erkannt und ist verboten.
*)

  TYPE 	TFBearbKstDS = RECORD
		           WinHdle : ADDRESS;
		           AendernKnopfHdle,
			   SperrenKnopfHdle,
			   EntsperrenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   KstIDHdle,
			   NameHdle,
			   JahrHdle,
			   GesperrtAmHdle,
			   KontingentHdle,
			   AequivalentHdle : ADDRESS;
(*  	      		   Kst: TKst;
			   KstID: TKstID;    *)
  	   		   KstIDString: String.TString;
  	      		   FTyp: CHAR;
  	      		 END;	
        TPFBearbKst = POINTER TO TFBearbKstDS;



(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfY1Pos=INT(210);
    KnopfY2Pos=INT(250);
    AendernKnopfXPos=INT(310);
    SperrenKnopfXPos=INT(40);
    EntsperrenKnopfXPos=INT(40);
    AbbrechenKnopfXPos=INT(310);
  VAR
    I: CARDINAL;
    KnopfText: String.TString;

    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);

    InitEinAusgabeFelder();

    KnopfText := String.Create();
    String.Schreibe(KnopfText,"Kostenstelle aendern");
    ichSelbst^.AendernKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AendernKnopfXPos, KnopfY1Pos, CAST(PROC,AendernKnopfCallback));

    String.Schreibe(KnopfText,"Kostenstelle sperren");
    ichSelbst^.SperrenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, SperrenKnopfXPos, KnopfY1Pos, CAST(PROC,SperrenKnopfCallback));

    String.Schreibe(KnopfText,"Kostenstelle entsperren");
    ichSelbst^.EntsperrenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, EntsperrenKnopfXPos, KnopfY2Pos, CAST(PROC,EntsperrenKnopfCallback));

    String.Schreibe(KnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, KnopfY2Pos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(KnopfText);

    TRAendernKnopfHdle:=ichSelbst^.AendernKnopfHdle;
    TRSperrenKnopfHdle:=ichSelbst^.SperrenKnopfHdle;
    TREntsperrenKnopfHdle:=ichSelbst^.EntsperrenKnopfHdle;
    TRAbbrechenKnopfHdle:=ichSelbst^.AbbrechenKnopfHdle;

    IF TRACE THEN WriteString("FBearbKst.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.AbbrechenKnopfCallback Begin"); WriteLn; END;

    DisposeFAnlegen();

    IF TRACE THEN WriteString("FBearbKst.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE AendernKnopfCallback();
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, KontingentString,
						AequivalentString: String.TString;
    MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
    Kontingent: CARDINAL;
    Aequivalent: CARDINAL;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBearbKst;
    Format: ConvTypes.ConvResults;
    DatenOkay: BOOLEAN;
(*  KstID: TKstID;
    Kst: TKst;
    Jahr: TJahr;
*)

  BEGIN
    IF TRACE THEN WriteString("FBearbKst.AendernKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);

    DatenOkay:=TRUE;

    MeldString:=String.Create();

    String.Lies(ichSelbst^.KstIDString, KstIDStr);
    WriteString("Aendern KstID:"); WriteString(KstIDStr); WriteString(":");

    KontingentString:=String.Create();
    LiesZeile(ichSelbst^.KontingentHdle, KontingentString); 
    String.Lies(KontingentString, KontingentStr); 
    WriteString("Kontingent:"); WriteString(KontingentStr); WriteString(":");

    AequivalentString:=String.Create();
    LiesZeile(ichSelbst^.AequivalentHdle, AequivalentString); 
    String.Lies(AequivalentString, AequivalentStr); 
    WriteString("Aequivalent:"); WriteString(AequivalentStr); WriteString(":"); WriteLn;


    String.Lies(ichSelbst^.KstIDString, KstIDStr);
    WriteString("Aendern KstID:"); WriteString(KstIDStr); WriteString(":");

    (* Kontingent Prfen und konvertieren *)
    IF StrToCardinal(KontingentStr,Kontingent) THEN
      WriteString("Kontingent:"); WriteCard(Kontingent,5); WriteString(":");
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Das Kontingent ist ungueltig (nicht positiv ganzzahlig)");
    END;

    (* Aequivalent Prfen und konvertieren *)
    IF StrToCardinal(AequivalentStr,Aequivalent) THEN
      WriteString("Aequivalent:"); WriteCard(Aequivalent,5); WriteString(":");
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Das Aequivalent ist ungueltig (nicht positivganzzahlig)");
    END;
    WriteLn;


    (* Sind die eingegeben Kostenstellendaten okay, dann wird die Kostenstelle upgedatet *)
    IF DatenOkay THEN
(*
       SetzeKontinginKst(Kontingent, ichSelbst^.Kst);
       SetzeAequivinKst(Aequivalent, ichSelbst^.Kst);
*)

(*
       IF BearbeitenAendernKst(ichSelbst^.Kst, MeldString) THEN
*)
         AusgebenMeldung("Kostenstelle wurde geaendert");
(*
       ELSE
         String.Lies(MeldString, MeldStr);
         Strings.Append("Meldung Kst:", MeldStr);
         AusgebenMeldung(MeldStr);
       END;
*)
    END;

    IF TRACE THEN WriteString("FBearbKst.AendernKnopfCallback End"); WriteLn; END;
  END AendernKnopfCallback;




PROCEDURE SperrenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFBearbKst;
    MeldString: String.TString;
    Text, MeldStr: ARRAY[1..200] OF CHAR;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.SperrenKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);

    MeldString:=String.Create();

(*
    IF SperrenKst(ichSelbst^.Kst, MeldString) THEN
*)
      AusgebenMeldung("Kostenstelle wurde gesperrt");
(*
    !!!!!!!  KST  MUSS NEU ANGEZEIGT WERDEN WEGEN SPERRDATUM    ELSE
      String.Lies(MeldString, MeldStr);
      Text:="Meldung Kst:";
      Strings.Append(MeldStr, Text);
      AusgebenMeldung(Text);
    END;
*)

    IF TRACE THEN WriteString("FBearbKst.SperrenKnopfCallback End"); WriteLn; END;
  END SperrenKnopfCallback;



PROCEDURE EntsperrenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFBearbKst;
    MeldString: String.TString;
    MeldStr: ARRAY[1..200] OF CHAR;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.EntsperrenKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);

    MeldString:=String.Create();

(*
    IF EntsperrenKst(ichSelbst^.Kst, MeldString) THEN
*)
      AusgebenMeldung("Kostenstelle wurde entsperrt");
(*
    !!!!!!!  KST  MUSS NEU ANGEZEIGT WERDEN WEGEN SPERRDATUM
    ELSE
      String.Lies(MeldString, MeldStr);
      Text:="Meldung Kst:";
      Strings.Append(MeldStr, Text);
      AusgebenMeldung(Text);
    END;
*)
    IF TRACE THEN WriteString("FBearbKst.EntsperrenKnopfCallback End"); WriteLn; END;
  END EntsperrenKnopfCallback;




PROCEDURE CreateFAnlegen(inKstIDString:String.TString);
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFBearbKst;
      meineAddr: ADDRESS;
      reaktProc: TProc;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.CreateFAnlegen Begin"); WriteLn; END;

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Kostenstelle bearbeiten");
    ALLOCATE (ichSelbst, TSIZE(TFBearbKstDS));
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    ichSelbst^.FTyp:="3";
    TRWinHdle:=ichSelbst^.WinHdle;

    meineAddr:= CAST(ADDRESS, ichSelbst);

    Push(ReaktFAnlegen, meineAddr);
    ichSelbst^.KstIDString:=inKstIDString;
    AktivFAnlegen();

    IF TRACE THEN WriteString("FBearbKst.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKst;

  BEGIN
    IF TRACE THEN WriteString("FBearbKst.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);
    TracePruefung(ichSelbst);

    LoeschenEinAusgabeFelder();
    EntferneKnopf(ichSelbst^.AendernKnopfHdle);
    EntferneKnopf(ichSelbst^.SperrenKnopfHdle);
    EntferneKnopf(ichSelbst^.EntsperrenKnopfHdle);
    EntferneFenster(ichSelbst^.WinHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);   (* nachFenster, damit Tastenprellen weniger gefhrlich *)
    DISPOSE(ichSelbst);

    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();

    IF TRACE THEN WriteString("FBearbKst.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.DeaktFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);
    TracePruefung(ichSelbst);

    (*  Deaktiviere Knpfe  *)
    SetzeKnopf(ichSelbst^.AendernKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.SperrenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.EntsperrenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);

    IF TRACE THEN WriteString("FBearbKst.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.ReaktFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);
    TracePruefung(ichSelbst);

    (* Aktiviere alle Knoepfe *)
    SetzeKnopf(ichSelbst^.AendernKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.SperrenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.EntsperrenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);

    IF TRACE THEN WriteString("FBearbKst.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEinAusgabeFelder();
  CONST
      XPos=INT(40);
      KstIDYPos=INT(50);
      KstIDLaen=INT(5);           
      NameYPos=INT(70);
      NameLaen=INT(20);           
      JahrYPos=INT(90);
      JahrLaen=INT(4);           
      KontingentYPos=INT(110);
      KontingentLaen=INT(4);           
      AequivalentYPos=INT(130);
      AequivalentLaen=INT(4); 
      GesperrtAmYPos=INT(150);
      GesperrtAmLaen=INT(10);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKst;
      Text, Inhalt: String.TString;
      MeldStr: ARRAY [1..200] OF CHAR;
      ZWString, MeldString: String.TString;
      DatumString, KstIDString, NameString, JahrString, KontingentString,GesperrtAmString,
						AequivalentString: String.TString;
      KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr,
      						GesperrtAmStr: ARRAY[1..200] OF CHAR;
      Kontingent: CARDINAL;
      Aequivalent: CARDINAL;
(*
      Jahr: Datum.TJahr;
      EingegebenAm,
      GesperrtAm,
      LiquidiertAm: Datum.TDatum;
      Datum: Datum.TDatum;
*)
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.InitEinAusgabeFelde Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();

    KstIDString:=ichSelbst^.KstIDString;


(*
    IF SearchKstZuKstID(ichSelbst^.KstID, ichSelbst^.Kst) THEN
      LiesNameinKst(NameString,ichSelbst^.Kst);
      LiesJahrinKst(Jahr,ichSelbst^.Kst);

      LiesKontinginKst(Kontingent,ichSelbst^.Kst);
      LiesAequivinKst(Aequivalent, ichSelbst^.Kst);
      LiesEingAminKst(EingegebenAm, ichSelbst^.Kst);
      LiesGesperrtAminKst(GesperrtAm, ichSelbst^.Kst);
      LiesLiquidAminKst(LiquidiertAm, ichSelbst^.Kst);
*)

      String.Schreibe(Text,"KostenstellenID:  ");
      String.Anhaengen(KstIDString, Text);
      ichSelbst^.KstIDHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, KstIDYPos);


      ZWString := String.Create();
      String.Schreibe(ZWString,"Name der Kostenstelle");
      NameString:=ZWString;

      String.Schreibe(Text,"Name:  ");
      String.Anhaengen(NameString, Text);
      ichSelbst^.NameHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, NameYPos);



    (*  Jahr ausgeben  *)
      DatumString := String.Create();
      String.Schreibe(DatumString,"01.01.2001");
(*
      Datum:=Datum.CreateDatum();
      IF Datum.DatumVonString(DatumString, Datum, MeldString) THEN
        Datum.SetzeJahrInDatum(Datum, Jahr);
      ELSE
        String.Lies(MeldString, MeldStr);
        Strings.Append("Meldung zu Datum:", MeldStr);
        AusgebenMeldung(MeldStr);
      END;
      DatumString:=Datum.DatumAlsString(Datum);
*)



      JahrString := String.Create();
      String.Auslesen(DatumString,6,4,JahrString);

      String.Schreibe(Text,"Jahr:  ");
      String.Anhaengen(JahrString, Text);
      ichSelbst^.JahrHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, JahrYPos);



      ZWString := String.Create();
      String.Schreibe(ZWString,"01.12.2001");
      GesperrtAmString:=ZWString;
(*
      IF Datum.IsDatumEternity(GesperrtAm) THEN
        ZWString := String.Create();
        String.Schreibe(ZWString,"nicht gesperrt");
        GesperrtAmString:=ZWString;              (* nur wenn UNDEF *)
*)
(*
      ELSE
        GesperrtAmString:=Datum.DatumAlsString(GesperrtAm);
      END;
*)
      String.Schreibe(Text,"gesperrt am:  ");
      String.Anhaengen(GesperrtAmString, Text);
      ichSelbst^.GesperrtAmHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GesperrtAmYPos);



      Kontingent:=123;
      WholeStr.CardToStr(Kontingent, KontingentStr);
      KontingentString := String.Create();
      String.Schreibe(KontingentString, KontingentStr);
      String.Schreibe(Text,"Kontingent:");
      ichSelbst^.KontingentHdle:=StelleZeileDar(Text, KontingentString, KontingentLaen,
	    					ichSelbst^.WinHdle, XPos, KontingentYPos);


	    									
      Aequivalent:=4711;
      WholeStr.CardToStr(Aequivalent, AequivalentStr);
      AequivalentString := String.Create();
      String.Schreibe(AequivalentString, AequivalentStr);
      String.Schreibe(Text,"quivalent:");
      ichSelbst^.AequivalentHdle:=StelleZeileDar(Text, AequivalentString, AequivalentLaen,
						ichSelbst^.WinHdle, XPos, AequivalentYPos);
						
 (* ist vielleicht fuer Stabilitt guenstig ?!?? *)						
      SetzeZeile(ichSelbst^.KontingentHdle, TRUE);
      SetzeZeile(ichSelbst^.AequivalentHdle, TRUE);

						
(*
    ELSE
      MeldString := String.Create();
      String.Schreibe(MeldString,"Die Kst wurden nicht gefunden !? KstID:");
      String.Anhaengen(KstIDString, MeldString);
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;
*)



    String.Dispose(Text);
    String.Dispose(Inhalt);



    TRKstIDHdle:=ichSelbst^.KstIDHdle;
    TRNameHdle:=ichSelbst^.NameHdle;
    TRJahrHdle:=ichSelbst^.JahrHdle;
    TRGesperrtAmHdle:=ichSelbst^.GesperrtAmHdle;
    TRKontingentHdle:=ichSelbst^.KontingentHdle;
    TRAequivalentHdle:=ichSelbst^.AequivalentHdle;

    IF TRACE THEN WriteString("FBearbKst.InitEinAusgabeFelde End"); WriteLn; END;
  END InitEinAusgabeFelder;



PROCEDURE LoeschenEinAusgabeFelder();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.LoeschenEinAusgabeFelde Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);
    TracePruefung(ichSelbst);

    EntferneMeldung(ichSelbst^.KstIDHdle);
    EntferneMeldung(ichSelbst^.NameHdle);
    EntferneMeldung(ichSelbst^.JahrHdle);
    EntferneMeldung(ichSelbst^.GesperrtAmHdle);
    EntferneZeile(ichSelbst^.KontingentHdle);
    EntferneZeile(ichSelbst^.AequivalentHdle);

    IF TRACE THEN WriteString("FBearbKst.LoeschenEinAusgabeFelde End"); WriteLn; END;
  END LoeschenEinAusgabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFBearbKst;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.AusgebenMeldung Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKst, meineAddr);
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);

    IF TRACE THEN WriteString("FBearbKst.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;

PROCEDURE TracePruefung(ichSelbst:TPFBearbKst);
   VAR
  BEGIN
    IF TRACE THEN WriteString("FBearbKst.TracePruefung Begin"); WriteLn; END;
    IF NOT (ichSelbst^.FTyp = "3") THEN
      WriteString(" FBearbKst.FTyp falsch");
    END;
    IF ichSelbst^.KstIDHdle = NIL THEN
      WriteString(" FBearbKst.KstIDHdle ist NIL");
    END;
    IF ichSelbst^.NameHdle = NIL THEN
      WriteString(" FBearbKst.NameHdle ist NIL");
    END;
    IF ichSelbst^.JahrHdle = NIL THEN
      WriteString(" FBearbKst.JahrHdle ist NIL");
    END;
    IF ichSelbst^.GesperrtAmHdle = NIL THEN
      WriteString(" FBearbKst.GesperrtAmHdle ist NIL");
    END;
    IF ichSelbst^.KontingentHdle = NIL THEN
      WriteString(" FBearbKst.KontingentHdle ist NIL");
    END;
    IF ichSelbst^.AequivalentHdle = NIL THEN
      WriteString(" FBearbKst.AequivalentHdle ist NIL");
    END;
    IF ichSelbst^.WinHdle = NIL THEN
      WriteString(" FBearbKst.WinHdle ist NIL");
    END;
    IF ichSelbst^.AendernKnopfHdle = NIL THEN
      WriteString(" FBearbKst.AendernKnopfHdle ist NIL");
    END;
    IF ichSelbst^.SperrenKnopfHdle = NIL THEN
      WriteString(" FBearbKst.SperrenKnopfHdle ist NIL");
    END;
    IF ichSelbst^.EntsperrenKnopfHdle = NIL THEN
      WriteString(" FBearbKst.EntsperrenKnopfHdle ist NIL");
    END;
    IF ichSelbst^.AbbrechenKnopfHdle = NIL THEN
      WriteString(" FBearbKst.AbbrechenKnopfHdle ist NIL");
    END;


    IF NOT (ichSelbst^.KstIDHdle = TRKstIDHdle) THEN
      WriteString(" FBearbKst.KstIDHdle ist ungl");
    END;
    IF NOT (ichSelbst^.NameHdle = TRNameHdle) THEN
      WriteString(" FBearbKst.NameHdle ist ungl");
    END;
    IF NOT (ichSelbst^.JahrHdle = TRJahrHdle) THEN
      WriteString(" FBearbKst.JahrHdle ist ungl");
    END;
    IF NOT (ichSelbst^.GesperrtAmHdle = TRGesperrtAmHdle) THEN
      WriteString(" FBearbKst.GesperrtAmHdle ist ungl");
    END;
    IF NOT (ichSelbst^.KontingentHdle = TRKontingentHdle) THEN
      WriteString(" FBearbKst.KontingentHdle ist ungl");
    END;
    IF NOT (ichSelbst^.AequivalentHdle = TRAequivalentHdle) THEN
      WriteString(" FBearbKst.AequivalentHdle ist ungl");
    END;
    IF NOT (ichSelbst^.WinHdle = TRWinHdle) THEN
      WriteString(" FBearbKst.WinHdle ist ungl");
    END;
    IF NOT (ichSelbst^.AendernKnopfHdle = TRAendernKnopfHdle) THEN
      WriteString(" FBearbKst.AendernKnopfHdle ist ungl");
    END;
    IF NOT (ichSelbst^.SperrenKnopfHdle = TRSperrenKnopfHdle) THEN
      WriteString(" FBearbKst.SperrenKnopfHdle ist ungl");
    END;
    IF NOT (ichSelbst^.EntsperrenKnopfHdle = TREntsperrenKnopfHdle) THEN
      WriteString(" FBearbKst.EntsperrenKnopfHdle ist ungl");
    END;
    IF NOT (ichSelbst^.AbbrechenKnopfHdle = TRAbbrechenKnopfHdle) THEN
      WriteString(" FBearbKst.AbbrechenKnopfHdle ist ungl");
    END;

    IF TRACE THEN WriteString("FBearbKst.TracePruefung End"); WriteLn; END;
  END TracePruefung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
(*  IF TRACE THEN WriteString("FBearbKst.StrToCardinal Begin"); WriteLn; END;   *)
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
(*    IF TRACE THEN WriteString("FBearbKst.StrToCardinal End"); WriteLn; END;   *)
      RETURN TRUE;
    ELSE
(*    IF TRACE THEN WriteString("FBearbKst.StrToCardinal End"); WriteLn; END;   *)
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
(*  IF TRACE THEN WriteString("FBearbKst.StrToInteger Begin"); WriteLn; END;   *)
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
(*    IF TRACE THEN WriteString("FBearbKst.StrToInteger End"); WriteLn; END;   *)
      RETURN TRUE;
    ELSE
(*    IF TRACE THEN WriteString("FBearbKst.StrToInteger End"); WriteLn; END;   *)
      RETURN FALSE;
    END;
  END StrToInteger;






CONST
  TRACE=FALSE;
VAR
  TRWinHdle : ADDRESS;
  TRAendernKnopfHdle,
  TRSperrenKnopfHdle,
  TREntsperrenKnopfHdle,
  TRAbbrechenKnopfHdle:ADDRESS;  		
  TRKstIDHdle,
  TRNameHdle,
  TRJahrHdle,
  TRGesperrtAmHdle,
  TRKontingentHdle,
  TRAequivalentHdle : ADDRESS;
BEGIN;
END FBearbKstT.
