IMPLEMENTATION MODULE FAendernVtrHKB;
FROM SYSTEM   IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen,JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;
FROM args     IMPORT GetArgs, ArgTable;
FROM InOut    IMPORT WriteString,WriteLn,WriteInt;

IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT FLadenSysVw;
IMPORT Vtre;
IMPORT Datum;
IMPORT SysDat;

TYPE TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;

VAR
  FensterHandle					: ADDRESS;
  VaterFenster					: ADDRESS;
  Vater									: ADDRESS;
  EndeKnopfHandle				: ADDRESS;
  VtrIdMeldTitel				: ADDRESS;
  VtrIdMeld							: ADDRESS;
  PersIdMeldTitel       : ADDRESS;
  PersIdMeld						: ADDRESS;
  KstIdMeldTitel				: ADDRESS;
  KstIdMeld							: ADDRESS;
  WeiterKnopfHandle			: ADDRESS;
  AendernKnopfHandle		: ADDRESS;
  StundenzahlZeile			: ADDRESS;
  TaetigkeitZeile				: ADDRESS;
  BegruendungZeile			: ADDRESS;
  GueltigBisZeile				: ADDRESS;
  GueltigVonZeile       : ADDRESS;
  ErstellungsDatumZeile	: ADDRESS;
  HkeListeHdle					: ADDRESS;
  Hinweis1 							: ADDRESS;
  VtrListHdle           : ADDRESS;
  VtrStrList						: Stringliste.TStringliste;
  globalVtrId_str				: String.TString;
  globalPersId_str			: String.TString;
  globalKstId_str				: String.TString;
(*----------------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE InitMaske();
(*Erzeugt die initiale Ein-Ausgabemaske *)
VAR Titel       : String.TString;
    HilfString  : String.TString;
BEGIN
  HilfString := String.Create();
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,350,450,CAST(PROC,EndeKnopfCallback));
  String.Schreibe(Titel,"VtrID");
  VtrIdMeldTitel := StelleMeldungDar(Titel,TRUE,FensterHandle,310,60);
  String.Schreibe(Titel,"Eingabe besttigen");
  WeiterKnopfHandle := StelleKnopfDar(Titel,FensterHandle,350,130,CAST(PROC,WeiterKnopfCallback));
END InitMaske;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
  EntferneKnopf(EndeKnopfHandle);
  EntferneFenster(FensterHandle);
  Dispose();
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowContentsOfVtre();
VAR  StrListe : Stringliste.TStringliste;
     s : String.TString;

BEGIN
   s := String.Create();
   VtrStrList := Vtre.GibVtrAlsStringlisteInVtr();
   (*Testdaten*)
   (*
   String.Schreibe(s,"30031 23456 12345 12.02.2001");
   Stringliste.Append(VtrStrList,s);
   String.Schreibe(s,"21112 44456 34355 12.02.2001");
   Stringliste.Append(VtrStrList,s);
   String.Schreibe(s,"00002 78964 23456 12.02.2001");
   Stringliste.Append(VtrStrList,s);
   String.Schreibe(s,"23424 46781 22245 12.02.2001");
   Stringliste.Append(VtrStrList,s);
   String.Schreibe(s,"87232 45631 11124 12.02.2001");
   Stringliste.Append(VtrStrList,s);
   String.Schreibe(s,"64444 45345 13455 12.02.2001");
   Stringliste.Append(VtrStrList,s);
   String.Schreibe(s,"75555 56435 43456 12.02.2001");
   *)

   String.Schreibe(s," VID   PID  KID    Datum");

   VtrListHdle := StelleListeDar(VtrStrList,s,4,FensterHandle,60,40,
   															 CAST(PROC,VtreListeCallback));
   Stringliste.Dispose(VtrStrList);
   String.Dispose(s);
END ShowContentsOfVtre;

(*----------------------------------------------------------------------------------------*)

PROCEDURE VtreListeCallback(element : INTEGER);
VAR Titel   : String.TString;
    Text : String.TString;
BEGIN
  IF VtrIdMeld <> NIL THEN
    EntferneMeldung(VtrIdMeld)
  END;
  Text := String.Create();

  LiesListenelement(VtrListHdle,element,Text);

  ExtractVtrId (Text,globalVtrId_str,0,5);
  ExtractPersId(Text,globalPersId_str,6,5);
  ExtractKstId (Text,globalKstId_str,12,5);

  VtrIdMeld  :=  StelleMeldungDar(globalVtrId_str,FALSE,FensterHandle,360,60);
  String.Dispose(Text);

END VtreListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE WeiterKnopfCallback();
VAR Abfragetext : String.TString;
    Titel				: String.TString;
    HilfString  : String.TString;
    HeuteString : String.TString;
    Heute   		: Datum.TDatum;

BEGIN
  EntferneKnopf(WeiterKnopfHandle);
  EntferneListe(VtrListHdle);
  HilfString := String.Create();
  Titel := String.Create();

  String.Schreibe(Titel,"PersID:");
  PersIdMeldTitel := StelleMeldungDar(Titel,TRUE,FensterHandle,60,90);
  PersIdMeld      := StelleMeldungDar(globalPersId_str,FALSE,FensterHandle,120,90);

  String.Schreibe(Titel,"KstID:");
  KstIdMeldTitel := StelleMeldungDar(Titel,TRUE,FensterHandle,60,120);
  KstIdMeld      := StelleMeldungDar(globalKstId_str,FALSE,FensterHandle,120,120);


  String.Schreibe(Titel,"Stundenzahl");
  StundenzahlZeile := StelleZeileDar(Titel,HilfString,4,FensterHandle,60,150);

  String.Schreibe(Titel,"Taetigkeit");
  TaetigkeitZeile := StelleZeileDar(Titel,HilfString,40,FensterHandle,60,180);

  String.Schreibe(Titel,"Begruendung");
  BegruendungZeile := StelleZeileDar(Titel,HilfString,70,FensterHandle,60,210);

  String.Schreibe(Titel,"GueltigVon");
  GueltigVonZeile := StelleZeileDar(Titel,HilfString,10,FensterHandle,60,240);

  String.Schreibe(Titel,"GueltigBis");
  GueltigBisZeile := StelleZeileDar(Titel,HilfString,10,FensterHandle,60,270);

  Heute       := SysDat.LiesSystemDatumInSysDat();
  HeuteString := String.Create();
 	String.Schreibe(HeuteString,StC(Datum.DatumAlsString(Heute)));
  String.Schreibe(Titel,"Erstellungsdatum");
  ErstellungsDatumZeile := StelleZeileDar(Titel,HeuteString,10,FensterHandle,60,300);
  String.Dispose(HeuteString);

  String.Schreibe(Titel,"(Storno: GueltigBis := GueltigVon || Aendern: GueltigBis vorziehen)");
  Hinweis1 := StelleMeldungDar(Titel,FALSE,FensterHandle,180,400);

  String.Schreibe(Titel,"nderungen bernehmen");
  AendernKnopfHandle := StelleKnopfDar(Titel,FensterHandle,310,350,CAST(PROC,AendernKnopfCallback));
END WeiterKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE AendernKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN

END AendernKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel : String.TString;
BEGIN
  VtrStrList := NIL;
  VtrIdMeld  := NIL;
  globalVtrId_str  := String.Create();
  globalPersId_str := String.Create();
  globalKstId_str  := String.Create();
  Vater := inFunct;
  Titel := String.Create();
  String.Schreibe(Titel,"V e r t r a g   S t o r n i e r e n  |  A e n d e r n");
  FensterHandle :=  NeuesFenster( Titel,140,80,500,800);
  InitMaske();
  ShowContentsOfVtre();
END Create;

(*----------------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
  VtrStrList := NIL;
  String.Dispose(globalVtrId_str);
  String.Dispose(globalPersId_str);
  String.Dispose(globalKstId_str);

  WriteString("SysVwLaden.Dispose");WriteLn;

  EntferneKnopf(EndeKnopfHandle);
  EntferneFenster(FensterHandle);
  AktiviereVater := CAST(TActVater,Vater);
  AktiviereVater();
END Dispose;
(*----------------------------------------------------------------------------------------*)

PROCEDURE ExtractVtrId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								     inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  WriteString(StC(selString));WriteLn();
  String.Equalize(inoutZiel,selString);
  WriteString(StC(inoutZiel));WriteLn();
  String.Dispose(selString);
END ExtractVtrId;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ExtractKstId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								     inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via inoutZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  String.Equalize(inoutZiel,selString);
  String.Dispose(selString);
END ExtractKstId;
(*----------------------------------------------------------------------------------------*)

PROCEDURE ExtractPersId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								      inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  String.Equalize(inoutZiel,selString);
  String.Dispose(selString);
END ExtractPersId;
(*----------------------------------------------------------------------------------------*)


END FAendernVtrHKB.