IMPLEMENTATION MODULE FAnlegen2VtrHKB;

FROM  SYSTEM   IMPORT  CAST, ADR, ADDRESS;
FROM  X_Grafik IMPORT  StelleListeDar,EntferneListe;
FROM  X_Grafik IMPORT  LiesListenelement, AendereListenelement;
FROM  X_Grafik IMPORT  StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM  X_Grafik IMPORT  StelleTextDar, EntferneText;
FROM  X_Grafik IMPORT  StelleMeldungDar, EntferneMeldung;
FROM  X_Grafik IMPORT  InitialisiereGrafik, StarteGrafik;
FROM  X_Grafik IMPORT  NeuesFenster, EntferneFenster;
FROM  X_Grafik IMPORT  MeldungAnzeigen,JaNeinAbfrage;
FROM  X_Grafik IMPORT  StringEingabeFenster, StringEingabeAuslesen;
FROM  X_Grafik IMPORT  StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM  X_Grafik IMPORT  StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM  X_Grafik IMPORT  LiesMenueEintrag, EntferneMenue;
FROM  args     IMPORT  GetArgs, ArgTable;
FROM  InOut    IMPORT  WriteString,WriteLn,WriteInt;
IMPORT  WholeStr;
IMPORT  Strings;
IMPORT  String;
IMPORT  Stringliste;
IMPORT  FLadenSysVw;
IMPORT  Datum;
IMPORT  HKe;
IMPORT  Ksten;
IMPORT  Vtre;
IMPORT  SysDat;
(*IMPORT  DialogLib;*)
IMPORT  HKB;

TYPE TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;
VAR
  FensterHandle		:  ADDRESS;
  VaterFenster		:  ADDRESS;
  Vater        		:  ADDRESS;
  EndeKnopfHandle	:  ADDRESS;
  WeiterKnopfHandle	:  ADDRESS;
  VtrSpeichKnopfHdle	:  ADDRESS;
  PersIdTitel		:  ADDRESS;
  PersIdMeld            :  ADDRESS;
  KstIdTitel    	:  ADDRESS;
  KstIdMeld             :  ADDRESS;
  StundenzahlZeile      :  ADDRESS;
  TaetigkeitZeile	:  ADDRESS;
  BegruendungZeile      :  ADDRESS;
  GueltigVonZeile	:  ADDRESS;
  GueltigBisZeile	:  ADDRESS;
  ErstellDatTitel       :  ADDRESS;
  ErstellDatMeld        :  ADDRESS;
  Meldung1              :  ADDRESS;
  SystemDatTitel        :  ADDRESS;
  SystemDatAnzeige      :  ADDRESS;
  HKeStringliste        :  Stringliste.TStringliste;
  KstStringliste        :  Stringliste.TStringliste;
  globalPersID          :  String.TString;
  globalVtrID           :  String.TString;
  globalKstID           :  String.TString;
  Grossvater            :  ADDRESS;
(*---------------------------------------------------------------------------------------*)

PROCEDURE InitMaske();

VAR Titel,
    Leerstring  : String.TString;
    HeuteString : String.TString;
    Heute       : Datum.TDatum;

BEGIN

  Leerstring := String.Create();
  Titel := String.Create();

  (*Systemdatum einlesen und ausgeben*)
  Heute           := SysDat.LiesSystemDatumInSysDat();
  HeuteString     := String.Create();
  String.Schreibe(HeuteString,StC(Datum.DatumAlsString(Heute)));
  String.Schreibe(Titel,"Systemdatum: ");
  SystemDatTitel   := StelleMeldungDar(Titel,FALSE,FensterHandle,60,30);
  SystemDatAnzeige := StelleMeldungDar(HeuteString,TRUE,FensterHandle,150,30);
  String.Dispose(HeuteString);

  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,550,300,CAST(PROC,EndeKnopfCallback));
  String.Schreibe(Titel,"PrsID:");
  PersIdTitel := StelleMeldungDar(Titel,FALSE,FensterHandle,260,60);
  PersIdMeld  := StelleMeldungDar(globalPersID,FALSE,FensterHandle,310,60);

  String.Schreibe(Titel,"KstID:");
  KstIdTitel := StelleMeldungDar(Titel,FALSE,FensterHandle,260,90);
  KstIdMeld  := StelleMeldungDar(globalKstID,FALSE,FensterHandle,310,90);

  Leerstring := String.Create();

  String.Schreibe(Titel,"Stundenzahl");
  StundenzahlZeile := StelleZeileDar(Titel,Leerstring,4,FensterHandle,60,120);

  String.Schreibe(Titel,"Taetigkeit");
  TaetigkeitZeile := StelleZeileDar(Titel,Leerstring,40,FensterHandle,60,150);

  String.Schreibe(Titel,"Begruendung");
  BegruendungZeile := StelleZeileDar(Titel,Leerstring,50,FensterHandle,60,180);

  String.Schreibe(Titel,"GueltigVon");
  GueltigVonZeile := StelleZeileDar(Titel,Leerstring,10,FensterHandle,60,210);

  String.Schreibe(Titel,"GueltigBis");
  GueltigBisZeile := StelleZeileDar(Titel,Leerstring,10,FensterHandle,60,240);

  String.Dispose(Leerstring);

  String.Schreibe(Titel,"Erstellungsdatum:");
  Heute           := SysDat.LiesSystemDatumInSysDat();
  HeuteString     := String.Create();
  String.Schreibe(HeuteString,StC(Datum.DatumAlsString(Heute)));
  ErstellDatTitel := StelleMeldungDar(Titel,FALSE,FensterHandle,60,270);
  ErstellDatMeld  := StelleMeldungDar(HeuteString,FALSE,FensterHandle,180,270);
  String.Dispose(HeuteString);

  String.Schreibe(Titel,"Vertrag Speichern");

  VtrSpeichKnopfHdle := StelleKnopfDar(Titel,FensterHandle,310,300,
  	                                     CAST(PROC,VtrSpeichKnopfCallback));

END InitMaske;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();

VAR Abfragetext : String.TString;

BEGIN

  Dispose();

END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE VtrSpeichKnopfCallback();
(* HK-ID erzeugen,Kst - Id erzeugen,Vtr erzeugen, Dialogfelder
   in die ID`s und in Vtr-Ado
   einlesen,abspeichern des Vertrages
*)
VAR
    sKostenStID  : String.TString;
    sStundenzahl : String.TString;
    sTaetigkeit  : String.TString;
    sBegruendung : String.TString;
    sGueltigVon  : String.TString;
    sGueltigBis  : String.TString;
    errmsg       : String.TString;
    meldString   : String.TString;
    Titel        : String.TString;
    HilfString   : String.TString;
    HeuteString  : String.TString;
    HilfsKrID    : HKe.TPersID;
    KstStID      : Ksten.TKstID;
    Vertrag      : Vtre.TVtr;
    CORRECT      : BOOLEAN;
    VonDatum  	 : Datum.TDatum;
    BisDatum		 : Datum.TDatum;
    Heute        : Datum.TDatum;
    ErstellDatum : Datum.TDatum;
    StdAsCARD    : CARDINAL;
    message      : ARRAY[0..255] OF CHAR;
    result       : WholeStr.ConvResults;

                      (*--------------Lokale Procedure von VtrSpeichKnopfCallback()---------------*)
    PROCEDURE TestPersID() : BOOLEAN;

    VAR s        : String.TString;

     BEGIN

     IF (String.Laenge(globalPersID) >= 5)THEN
      RETURN TRUE
     ELSE
      s := String.Create();
      String.Schreibe(s,"Fehlerhafte PersID");
      MeldungAnzeigen(s);
      String.Dispose(s);
      RETURN FALSE;
     END;

    END TestPersID;
                           (*-------Lokale Procedure von VtrSpeichKnopfCallback()----------------*)

    PROCEDURE TestKstenID() : BOOLEAN;

    VAR s        : String.TString;

    BEGIN

     IF (String.Laenge(globalKstID) >= 5) THEN
      RETURN TRUE;
     ELSE
      s := String.Create();
      String.Schreibe(s,"Fehlerhafte KstID");
      MeldungAnzeigen(s);
      String.Dispose(s);
      RETURN FALSE;
     END;

    END TestKstenID;
                          (*---------Lokale Procedure von VtrSpeichKnopfCallback()-------------*)

    PROCEDURE TestStdZahl() : BOOLEAN;

    VAR ok : BOOLEAN;
        s  : String.TString;

    BEGIN

       CASE result OF
         WholeStr.strAllRight      : WriteString("VtrSpeichKnopfCallback: sStundenzahl o.k");
      	  	  		     WriteLn();
      	  	  		     ok := TRUE;
         | WholeStr.strOutOfRange  : WriteString("VtrSpeichKnopfCallback:");
    				     WriteString("sStundenzahl - Bereichsfehler"); WriteLn;
       				     ok := FALSE;
         | WholeStr.strWrongFormat : WriteString("VtrSpeichKnopfCallback:");
     				     WriteString("sStundenzahl - Formatfehler");   WriteLn;
                        	     ok := FALSE;
         | WholeStr.strEmpty       : WriteString("VtrSpeichKnopfCallback:");
    				     WriteString("sStundenzahl - LeererString");   WriteLn;
                                     ok := FALSE;
      END;
      IF ok THEN
        RETURN(TRUE);
      ELSE
        s := String.Create();
        String.Schreibe(s,"Stundenzahl: Fehlerhafte Eingabe");
        MeldungAnzeigen(s);
        RETURN(FALSE);
      END;

    END TestStdZahl;

                   (*---------------Lokale Procedure von VtrSpeichKnopfCallback()---------------------*)

    PROCEDURE TestTaetigkeit() : BOOLEAN;

    VAR errmsg   : String.TString;

    BEGIN

     RETURN TRUE;

    END TestTaetigkeit;

                    (*------------Lokale Procedure von VtrSpeichKnopfCallback()-----------------------*)

    PROCEDURE TestGueltigVon() : BOOLEAN;

    VAR errmsg   : String.TString;
        s        : String.TString;

    BEGIN
      RETURN TRUE;

    (*
     IF DialogLib.DatumKorrekt(sGueltigVon,errmsg) THEN
       WriteString(StC(errmsg));
       RETURN TRUE;
     ELSE
       s := String.Create();
       String.Schreibe(s,"GueltigVon: ");
       String.Anhaengen(errmsg,s);
       MeldungAnzeigen(s);
       String.Dispose(s);
       RETURN FALSE;
     END;
     String.Dispose(errmsg);
    *)
   END TestGueltigVon;
(*------------------------------Lokale Procedure-----------------------------------*)


    PROCEDURE TestGueltigBis() : BOOLEAN;

    VAR errmsg  : String.TString;
        s       : String.TString;

    BEGIN
      RETURN TRUE;
    (*
      IF DialogLib.DatumKorrekt(sGueltigBis,errmsg) THEN
         WriteString(StC(errmsg));
       RETURN TRUE;
     ELSE
       s := String.Create();
       String.Schreibe(s,"GueltigBis: ");
       String.Anhaengen(errmsg,s);
       MeldungAnzeigen(s);
       String.Dispose(s);
       RETURN FALSE;
     END;
     String.Dispose(errmsg);
    *)
    END TestGueltigBis;

            (*-----------------HauptProcedure von VtrSpeichKnopfCallback() -------------------*)

BEGIN

  CORRECT := TRUE;

  (* Lokale Varialblen Initialisieren *)
  sStundenzahl := String.Create();
  sTaetigkeit  := String.Create();
  sBegruendung := String.Create();
  sGueltigVon  := String.Create();
  sGueltigBis  := String.Create();

  (* Dialogfelder einlesen *)
  LiesZeile(StundenzahlZeile,sStundenzahl);
  LiesZeile(TaetigkeitZeile,sTaetigkeit);
  LiesZeile(BegruendungZeile,sBegruendung);
  LiesZeile(GueltigVonZeile,sGueltigVon);
  LiesZeile(GueltigBisZeile,sGueltigBis);


  (* Teste die Formulareingaben auf Korrektheit *)
  WriteString(" ");WriteLn;
  CORRECT := TestPersID();
  IF CORRECT THEN
    Cut(globalPersID,0,5);
  END;
   						
  IF CORRECT THEN
   CORRECT := TestKstenID();
  END;
                          WriteString(" ");WriteLn;
  IF CORRECT THEN
   Cut(globalKstID,0,5);
  END;

  IF CORRECT THEN
   WholeStr.StrToCard(StC(sStundenzahl),StdAsCARD,result);
   CORRECT := TestStdZahl();
  END;

  IF CORRECT THEN
   CORRECT := TestTaetigkeit();
  END;

  IF CORRECT THEN
   CORRECT := TestGueltigVon();
  END;

  IF CORRECT THEN
   CORRECT := TestGueltigBis();
  END;

  (*
     -- Falls Eingaben korrekt, erzeuge Vertrag V und bertrage die Eingaben nach V
     -- falls Fehler auftreten, Abbruch des Prozesses und Rckkehr zum Hauptfenster
     -- die Fehlermeldungen werden auf der Konsole ausgegeben
  *)
  IF CORRECT THEN
    Vertrag := Vtre.CreateVtr();
  END;

  IF CORRECT THEN

   (* Setze Vertrag.PersonalID *)
   HilfsKrID := HKe.StringInPersID(globalPersID);
   Vtre.SetzePersIDinVtr (Vertrag,HilfsKrID);

   (* Setze Vertrag.KostenstellenID *)
   KstStID := Ksten.StringInKstID (globalKstID);
   Vtre.SetzeKstIDinVtr (Vertrag,KstStID);

   (* Setze Vertrag.Stundenzahl *)
   IF (CORRECT = FALSE) THEN
      meldString := String.Create();
      String.Schreibe(meldString,"Stundenzahl: Formatfehler");
      MeldungAnzeigen(meldString);
      String.Dispose(meldString);
   END;

   IF CORRECT THEN
    CORRECT := Vtre.SetzeStdzahlinVtr(Vertrag,StdAsCARD);
   END;

   (* Setze Vertrag.Taetigkeit*)
   IF CORRECT THEN
    CORRECT   := Vtre.SetzeTaetigktinVtr (Vertrag,sTaetigkeit)
   END;

   (* Setze Vertrag.Begruendeung*)
   IF CORRECT THEN
    CORRECT   := Vtre.SetzeBegruendinVtr (Vertrag,sBegruendung);
   END;

   (* GultigVon - String nach Datum*)
   IF CORRECT THEN
    VonDatum := Datum.CreateDatum();
    CORRECT  := Datum.DatumVonString (sGueltigVon,VonDatum,errmsg);
    IF NOT CORRECT THEN
      WriteString(StC(errmsg));WriteLn();;
      MeldungAnzeigen(errmsg);
      String.Dispose(errmsg);
    END;
   END;

   (* GueltigBis - String nach Datum *)
   IF CORRECT THEN
    BisDatum := Datum.CreateDatum();
    CORRECT  := Datum.DatumVonString(sGueltigBis,BisDatum,errmsg);
    IF NOT(CORRECT) THEN
       MeldungAnzeigen(errmsg);
       String.Dispose(errmsg);
    END;
   END;

   (* Aktuelles Datum ermitteln in *)
   IF CORRECT THEN
    Heute           := SysDat.LiesSystemDatumInSysDat();
    HeuteString     := String.Create();
    String.Schreibe(HeuteString,StC(Datum.DatumAlsString(Heute)));
    CORRECT := Datum.DatumVonString(HeuteString,ErstellDatum,errmsg);
    IF NOT CORRECT THEN
     MeldungAnzeigen(errmsg);
     String.Dispose(errmsg);
    END;
     String.Dispose(HeuteString);
   END;

   (* Setze Vertrag.GueltigVon und Vertrag.Gueltig.Bis und Vertrag.Erstellungsdatum *)
   IF CORRECT THEN
    Vtre.SetzeGueltigVoninVtr (Vertrag,VonDatum);
    Vtre.SetzeGueltigBisinVtr (Vertrag,BisDatum);
    CORRECT := Vtre.SetzeErstellDatinVtr(Vertrag,ErstellDatum);
   END;


  END;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

  (* Falls CORRECT dann Vertrag abspeichern *)
  IF CORRECT THEN
    CORRECT := HKB.BearbeitenNeuVtr ( Vertrag,errmsg);
    IF NOT CORRECT THEN
       MeldungAnzeigen(errmsg);
       String.Dispose(errmsg);
    END;
  END;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

  (* Abschlumeldungen ber Erfolg/Mierfolg ber Anlegen eines Neuvertrages*)
  IF CORRECT THEN
    (* Formular entfernen *)
    EntferneKnopf(VtrSpeichKnopfHdle);
    EntferneMeldung( PersIdTitel);
    EntferneMeldung( PersIdMeld);
    EntferneMeldung( KstIdTitel);
    EntferneMeldung( KstIdMeld);
    EntferneZeile( StundenzahlZeile);
    EntferneZeile( TaetigkeitZeile);
    EntferneZeile( BegruendungZeile);
    EntferneMeldung( GueltigVonZeile);
    EntferneMeldung( GueltigBisZeile);
    EntferneMeldung( ErstellDatTitel);
    EntferneMeldung( ErstellDatMeld);

    meldString := String.Create();
    String.Schreibe(meldString," Vertrag erzeugt und gespeichert ");
    Meldung1 := StelleMeldungDar(meldString,TRUE,FensterHandle,250,150);
    String.Dispose(meldString);
  ELSE
    (* Neuerzeugung oder Einfuegen des Vertrages milungen-->Konsolenausgabe *)
    WriteString(" Vertrag Anlegen milungen ");
  END;

  (* Aufrumen *)
  String.Dispose(sStundenzahl);
  String.Dispose(sTaetigkeit);
  String.Dispose(sBegruendung);
  String.Dispose(sGueltigVon);
  String.Dispose(sGueltigBis);

END VtrSpeichKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE Create(inpersid : ADDRESS; inkstid : ADDRESS; ingrossvater : ADDRESS);
VAR Titel : String.TString;
BEGIN

  globalPersID  := CAST(String.TString,inpersid);
  globalKstID   := CAST(String.TString,inkstid);
  Grossvater    := ingrossvater;

  Titel := String.Create();
  String.Schreibe(Titel,"V e r t r a g   E r z e u g e n  &  B u c h e n...");
  FensterHandle :=  NeuesFenster( Titel,140,80,400,800);
  InitMaske();
END Create;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
    EntferneFenster(FensterHandle);
    (*
       -- AUFRUF KINDFENSTER, mit bergabeparametern VertragsId.PersonalId und
       -- Addresse des aufrufenden Vaterfensters hiks.
       -- Das Vaterfenster wird aus dem soeben zu kreierenden Kindfenster aufgerufen
    *)
    AktiviereVater := CAST(TActVater,Grossvater);
    AktiviereVater();
END Dispose;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Cut(VAR inoutString : String.TString;inStart,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inoutString, dannRckgabe via inoutString*)
VAR ok : BOOLEAN;
BEGIN
  IF (String.Laenge(inoutString) >= 5) THEN
    String.Auslesen (inoutString,inStart,inAnzahl,inoutString);
  END;
END Cut;

(*----------------------------------------------------------------------------------------*)


PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach ARRAY OF CHAR = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)


END FAnlegen2VtrHKB.

