IMPLEMENTATION MODULE FAnlegenVtrHKB;

FROM  SYSTEM   IMPORT  CAST, ADR, ADDRESS;
FROM  X_Grafik IMPORT  StelleListeDar,EntferneListe;
FROM  X_Grafik IMPORT  LiesListenelement, AendereListenelement;
FROM  X_Grafik IMPORT  StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM  X_Grafik IMPORT  StelleTextDar, EntferneText;
FROM  X_Grafik IMPORT  StelleMeldungDar, EntferneMeldung;
FROM  X_Grafik IMPORT  InitialisiereGrafik, StarteGrafik ;
FROM  X_Grafik IMPORT  NeuesFenster, EntferneFenster;
FROM  X_Grafik IMPORT  MeldungAnzeigen,JaNeinAbfrage;
FROM  X_Grafik IMPORT  StringEingabeFenster, StringEingabeAuslesen;
FROM  X_Grafik IMPORT  StelleMenueDar, SetzeMenueEintrag, SetzeMenue,StelleListeDar;
FROM  X_Grafik IMPORT  StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM  X_Grafik IMPORT  LiesMenueEintrag, EntferneMenue;
FROM  args     IMPORT  GetArgs, ArgTable;
FROM  InOut    IMPORT  WriteString,WriteLn,WriteInt;


IMPORT  WholeStr;
IMPORT  Strings;
IMPORT  String;
IMPORT  Stringliste;
IMPORT  FLadenSysVw;
IMPORT  Datum;
IMPORT  HKe;
IMPORT  Ksten;
IMPORT  Vtre;
IMPORT  SysDat;
IMPORT  DialogLib;
IMPORT  FAnlegen2VtrHKB;
IMPORT  HKB;
IMPORT  Konden;

TYPE TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;

VAR
  FensterHandle	     : ADDRESS;
  VaterFenster	     : ADDRESS;
  Vater        	     : ADDRESS;
  EndeKnopfHandle    : ADDRESS;
  WeiterKnopfHandle  : ADDRESS;
  VtrSpeichKnopfHdle : ADDRESS;
  PersIdZeile	     : ADDRESS;
  KstIdZeile	     : ADDRESS;
  StundenzahlZeile   : ADDRESS;
  TaetigkeitZeile    : ADDRESS;
  BegruendungZeile   : ADDRESS;
  GueltigVonZeile    : ADDRESS;
  GueltigBisZeile    : ADDRESS;
  ErstellDatZeile    : ADDRESS;
  KstenListeHdle     : ADDRESS;
  HkeListeHdle       : ADDRESS;
  Meldung1           : ADDRESS;
  PersIDTitel        : ADDRESS;
  PersIDMeldung      : ADDRESS;
  KstIDTitel         : ADDRESS;
  KstIDMeldung       : ADDRESS;
  HKeStringliste     : Stringliste.TStringliste;
  KstStringliste     : Stringliste.TStringliste;
  globalPersID       : String.TString;
  globalVtrID        : String.TString;
  globalKstID        : String.TString;
(*----------------------------------------------------------------------------------------*)

PROCEDURE InitMaske();
VAR Titel,Text,
    Leerstring  : String.TString;
BEGIN
  Leerstring := String.Create();
  Titel      := String.Create();
  Text       := String.Create();

  String.Schreibe(Titel,"PrsID");
  PersIDTitel := StelleMeldungDar(Titel,TRUE,FensterHandle,340,60);
  String.Schreibe(Text,"");
  PersIDMeldung := StelleMeldungDar(Text,TRUE,FensterHandle,380,60);

  String.Schreibe(Titel,"KstID");
  KstIDTitel    := StelleMeldungDar(Titel,TRUE,FensterHandle,340,80);
  String.Schreibe(Text,"");
  PersIDMeldung := StelleMeldungDar(Text,TRUE,FensterHandle,360,80);

  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,340,240,CAST(PROC,EndeKnopfCallback));
  String.Schreibe(Titel,"-->Eingabe besttigen");
  WeiterKnopfHandle := StelleKnopfDar(Titel,FensterHandle,340,180,CAST(PROC,WeiterKnopfCallback));
END InitMaske;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
  Dispose();
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE VtrSpeichKnopfCallback();

VAR sPersonalID  : String.TString;
    sKostenStID  : String.TString;
    sStundenzahl : String.TString;
    sTaetigkeit  : String.TString;
    sBegruendung : String.TString;
    sGueltigVon  : String.TString;
    sGueltigBis  : String.TString;
    sErstellDat  : String.TString;
    errmsg       : String.TString;
    meldString   : String.TString;
    Titel        : String.TString;
    HilfString   : String.TString;
    HilfsKrID    : HKe.TPersID;
    KstStID      : Ksten.TKstID;
    Vertrag      : Vtre.TVtr;
    CORRECT      : BOOLEAN;
    VonDatum  	 : Datum.TDatum;
    BisDatum	 : Datum.TDatum;
    ErstellDatum : Datum.TDatum;
    StdAsCARD    : CARDINAL;
    message      : ARRAY[0..255] OF CHAR;
    result       : WholeStr.ConvResults;
    globalVtrID  : String.TString;

(*-------------------------------Lokale Procedure-------------------------------*)
    PROCEDURE TestPersID() : BOOLEAN;
    VAR s        : String.TString;
     BEGIN
     IF (String.Laenge(sPersonalID) >= 5)THEN
      RETURN TRUE
     ELSE
      s := String.Create();
      String.Schreibe(s,"Fehlerhafte PersID");
      MeldungAnzeigen(s);
      String.Dispose(s);
      RETURN FALSE;
     END;
    END TestPersID;
(*-------------------------------Lokale Procedure--------------------------------*)

    PROCEDURE TestKstenID() : BOOLEAN;
    VAR s        : String.TString;
    BEGIN
     IF (String.Laenge(sKostenStID) >= 5) THEN
      RETURN TRUE;
     ELSE
      s := String.Create();
      String.Schreibe(s,"Fehlerhafte KstID");
      MeldungAnzeigen(s);
      String.Dispose(s);
      RETURN FALSE;
     END;
    END TestKstenID;
(*-------------------------------Lokale Procedure---------------------------------*)

    PROCEDURE TestStdZahl() : BOOLEAN;
    VAR ok : BOOLEAN;
        s  : String.TString;
    BEGIN
       CASE result OF
         WholeStr.strAllRight      : WriteString("VtrSpeichKnopfCallback: sStundenzahl o.k");
      	  	  		     WriteLn();
      	  	  		     ok := TRUE;
         | WholeStr.strOutOfRange  : WriteString("VtrSpeichKnopfCallback:");
    				     WriteString("sStundenzahl - Bereichsfehler"); WriteLn;
       				     ok := FALSE;
         | WholeStr.strWrongFormat : WriteString("VtrSpeichKnopfCallback:");
     				     WriteString("sStundenzahl - Formatfehler");   WriteLn;
                        	     ok := FALSE;
         | WholeStr.strEmpty       : WriteString("VtrSpeichKnopfCallback:");
    				     WriteString("sStundenzahl - LeererString");   WriteLn;
                                     ok := FALSE;
      END;
      IF ok THEN
        RETURN(TRUE);
      ELSE
        s := String.Create();
        String.Schreibe(s,"Stundenzahl: Fehlerhafte eingabe");
        MeldungAnzeigen(s);
        RETURN(FALSE);
      END;
    END TestStdZahl;
(*-------------------------------Lokale Procedure---------------------------------*)

    PROCEDURE TestTaetigkeit() : BOOLEAN;
    VAR errmsg   : String.TString;
    BEGIN
     RETURN TRUE;
    END TestTaetigkeit;

(*-------------------------------Lokale Procedure---------------------------------*)

    PROCEDURE TestGueltigVon() : BOOLEAN;
    VAR errmsg   : String.TString;
        s        : String.TString;
    BEGIN
     IF DialogLib.DatumKorrekt(sGueltigVon,errmsg) THEN
       WriteString(StC(errmsg));
       RETURN TRUE;
     ELSE
       s := String.Create();
       String.Schreibe(s,"GueltigVon: ");
       String.Anhaengen(errmsg,s);
       MeldungAnzeigen(s);
       String.Dispose(s);
       RETURN FALSE;
     END;
     String.Dispose(errmsg);
    END TestGueltigVon;
(*------------------------------Lokale Procedure-----------------------------------*)

    PROCEDURE TestGueltigBis() : BOOLEAN;
    VAR errmsg  : String.TString;
        s       : String.TString;
    BEGIN
     IF DialogLib.DatumKorrekt(sGueltigBis,errmsg) THEN
         WriteString(StC(errmsg));
       RETURN TRUE;
     ELSE
       s := String.Create();
       String.Schreibe(s,"GueltigBis: ");
       String.Anhaengen(errmsg,s);
       MeldungAnzeigen(s);
       String.Dispose(s);
       RETURN FALSE;
     END;
     String.Dispose(errmsg);
    END TestGueltigBis;

(*----------------------------------------------------------------------------------*)

BEGIN
  CORRECT := TRUE;

  (* Lokale Varialblen Initialisieren *)
  sPersonalID  := String.Create();
  sKostenStID  := String.Create();
  sStundenzahl := String.Create();
  sTaetigkeit  := String.Create();
  sBegruendung := String.Create();
  sGueltigVon  := String.Create();
  sGueltigBis  := String.Create();
  sErstellDat  := String.Create();

  (* Dialogfelder einlesen *)
  LiesZeile(PersIdZeile,sPersonalID);
  WriteString(StC(sPersonalID));WriteLn();
  LiesZeile(KstIdZeile,sKostenStID);
  LiesZeile(StundenzahlZeile,sStundenzahl);
  LiesZeile(TaetigkeitZeile,sTaetigkeit);
  LiesZeile(BegruendungZeile,sBegruendung);
  LiesZeile(GueltigVonZeile,sGueltigVon);
  LiesZeile(GueltigBisZeile,sGueltigBis);
  LiesZeile(ErstellDatZeile,sErstellDat);
  (* Die eingelesenen Strings in die ADO - Felder einlesen *)


  (* Teste die Formulareingaben auf Korrektheit *)

  CORRECT := TestPersID();
  IF CORRECT THEN
    Cut(sPersonalID,0,5);
  END;

  IF CORRECT THEN
   CORRECT := TestKstenID();
  END;

  IF CORRECT THEN
   Cut(sKostenStID,0,5);
  END;

  IF CORRECT THEN
   WholeStr.StrToCard(StC(sStundenzahl),StdAsCARD,result);
   CORRECT := TestStdZahl();
  END;

  IF CORRECT THEN
   CORRECT := TestTaetigkeit();
  END;

  IF CORRECT THEN
   CORRECT := TestGueltigVon();
  END;

  IF CORRECT THEN
   CORRECT := TestGueltigBis();
  END;

  (*
     -- Falls Eingaben korrekt, erzeuge Vertrag V und bertrage die Eingaben nach V
     -- falls Fehler auftreten, Abbruch des Prozesses und Rckkehr zum Hauptfenster
     -- die Fehlermeldungen werden auf der Konsole ausgegeben
  *)

  IF CORRECT THEN
    Vertrag := Vtre.CreateVtr();
  END;

  IF CORRECT THEN

   (* Setze Vertrag.PersonalID *)
   HilfsKrID := HKe.StringInPersID(sPersonalID);
   Vtre.SetzePersIDinVtr (Vertrag,HilfsKrID);


   (* Setze Vertrag.KostenstellenID *)
   KstStID := Ksten.StringInKstID (sKostenStID);
   Vtre.SetzeKstIDinVtr (Vertrag,KstStID);

   (* Setze Vertrag.Stundenzahl *)
   IF (CORRECT = FALSE) THEN
      meldString := String.Create();
      String.Schreibe(meldString,"Stundenzahl: Formatfehler");
      MeldungAnzeigen(meldString);
      String.Dispose(meldString);
   END;

   IF CORRECT THEN
    CORRECT := Vtre.SetzeStdzahlinVtr(Vertrag,StdAsCARD);
   END;

   (* Setze Vertrag.Taetigkeit*)
   IF CORRECT THEN
    CORRECT   := Vtre.SetzeTaetigktinVtr (Vertrag,sTaetigkeit)
   END;

   (* Setze Vertrag.Begruendeung*)
   IF CORRECT THEN
    CORRECT   := Vtre.SetzeBegruendinVtr (Vertrag,sBegruendung);
   END;

   (* String nach Datum*)

   IF CORRECT THEN
    VonDatum := Datum.CreateDatum();
    CORRECT  := Datum.DatumVonString (sGueltigVon,VonDatum,errmsg);
    WriteString(StC(errmsg));WriteLn();
    IF NOT(CORRECT) THEN
    	HilfString := String.Create();
    	String.Schreibe(HilfString,"GueltigVon: ");
    	String.Anhaengen(errmsg,HilfString);
    	MeldungAnzeigen(HilfString);
    	String.Dispose(HilfString);
    END;
   END;

   (* String nach Datum *)
   IF CORRECT THEN
    BisDatum := Datum.CreateDatum();
    CORRECT  := Datum.DatumVonString(sGueltigBis,BisDatum,errmsg);
    WriteString(StC(errmsg));WriteLn();
    IF NOT(CORRECT) THEN
    	HilfString := String.Create();
    	String.Schreibe(HilfString,"GueltigBis: ");
    	String.Anhaengen(errmsg,HilfString);
    	MeldungAnzeigen(HilfString);
    	String.Dispose(HilfString);
    END;
   END;


   (* String nach Datumg*)
   IF CORRECT THEN
    CORRECT := Datum.DatumVonString(sErstellDat,ErstellDatum,errmsg);
    WriteString(StC(errmsg));WriteLn();
   END;

   (* Setze Vertrag.GueltigVon und Vertrag.Gueltig.Bis und Vertrag.Erstellungsdatum *)
   IF CORRECT THEN
    Vtre.SetzeGueltigVoninVtr (Vertrag,VonDatum);
    Vtre.SetzeGueltigBisinVtr (Vertrag,BisDatum);
    CORRECT := Vtre.SetzeErstellDatinVtr(Vertrag,ErstellDatum);
   END;

   IF CORRECT THEN
    WriteString("VtrSpeichKnopfCallback: Vtr erzeugt und initialisiert"); WriteLn();
   ELSE
    WriteString("VtrSpeichKnopfCallback: Erzeugung der Vetr.Daten milungen");
   END;

  END;
 (* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
  (*
     -- Falls CORRECT dann Vertrag abspeichern
  *)
   IF CORRECT THEN
     CORRECT := HKB.BearbeitenNeuVtr ( Vertrag,errmsg);
     WriteString("VtrSpeichKnopfCallback: ");WriteString(StC(errmsg));
     WriteLn;
   END;
 (* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  (* Abschlumeldungen ber Erfolg/Mierfolg ber Anlegen eines Neuvertrages*)
  IF CORRECT THEN
    (* Formular entfernen *)
    EntferneKnopf(VtrSpeichKnopfHdle);
    EntferneZeile(PersIdZeile);
    EntferneZeile(KstIdZeile);
    EntferneZeile(StundenzahlZeile);
    EntferneZeile(BegruendungZeile);
    EntferneZeile(TaetigkeitZeile);
    EntferneZeile(GueltigVonZeile);	
    EntferneZeile(GueltigBisZeile);
    EntferneZeile(ErstellDatZeile);
    meldString := String.Create();
    String.Schreibe(meldString," Vertrag erzeugt und gespeichert ");
    Meldung1 := StelleMeldungDar(meldString,TRUE,FensterHandle,250,150);
    String.Dispose(meldString);
  ELSE
    (* Neuerzeugung oder Einfuegen des Vertrages milungen-->Konsolenausgabe *)
    WriteString(" Vertrag Anlegen milungen ");
  END;

  (* Aufrumen *)
  String.Dispose(sPersonalID);
  String.Dispose(sKostenStID);
  String.Dispose(sStundenzahl);
  String.Dispose(sTaetigkeit);
  String.Dispose(sBegruendung);
  String.Dispose(sGueltigVon);
  String.Dispose(sGueltigBis);
  String.Dispose(sErstellDat);

END VtrSpeichKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowContentsOfHke();
VAR  s        : String.TString;
     strlist  : Stringliste.TStringliste;

BEGIN
   s := String.Create();
   WriteString("ShowContentsOfHKe1");WriteLn();
   HKeStringliste := HKe.GibHKeAlsStringlisteinHKe();
   WriteString("ShowContentsOfHKe2");WriteLn();

   (* Aufbau der verkrzten Stringliste *)
   strlist := Stringliste.Create();
   Stringliste.GoStart(HKeStringliste);
   WHILE NOT Stringliste.OffEnd(HKeStringliste) DO
   	s := Stringliste.Current(HKeStringliste);
   	Cut(s,0,32);
   	Stringliste.Append(strlist,s);
   	Stringliste.StepNext(HKeStringliste);
     END;
     String.Schreibe(s,"  Id      Name   ");
     HkeListeHdle := StelleListeDar(strlist,s,4,FensterHandle,60,40,CAST(PROC,HkeListeCallback));
   Stringliste.Dispose(strlist);
   Stringliste.Dispose(HKeStringliste);
   String.Dispose(s);

END ShowContentsOfHke;

(*----------------------------------------------------------------------------------------*)

PROCEDURE HkeListeCallback(element : INTEGER);

BEGIN
  LiesListenelement(HkeListeHdle,element,globalPersID);
  EntferneMeldung(PersIDMeldung);
  PersIDMeldung :=  StelleMeldungDar(globalPersID,FALSE,FensterHandle,400,60);
END HkeListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowContentsOfKsten();
VAR  StrListe : Stringliste.TStringliste;
     s : String.TString;

BEGIN
   s := String.Create();
   WriteString("ShowContentsOfKsten1");WriteLn();
   KstStringliste := Ksten.GibKstenAlsStringlisteInKsten();
   (* Aufbau einer verkrzten Stringliste *)
   StrListe := Stringliste.Create();

   Stringliste.GoStart(KstStringliste);
   WHILE NOT Stringliste.OffEnd(KstStringliste) DO
   	s := Stringliste.Current(KstStringliste);
   	Cut(s,0,26);
   	Stringliste.Append(StrListe,s);
   	Stringliste.StepNext(KstStringliste);
     END;
     String.Schreibe(s,"  ID      Kostenstelle                ");
     KstenListeHdle := StelleListeDar(StrListe,s,4,FensterHandle,60,180,
   		       		CAST(PROC,KstenListeCallback));

   (* Stringliste.Dispose(StrListe); *)
   Stringliste.Dispose(KstStringliste);
   String.Dispose(s);

END ShowContentsOfKsten;

(*----------------------------------------------------------------------------------------*)

PROCEDURE KstenListeCallback(element : INTEGER);

BEGIN
  LiesListenelement(KstenListeHdle,element,globalKstID);
  EntferneMeldung(KstIDMeldung);
  KstIDMeldung := StelleMeldungDar(globalKstID,FALSE,FensterHandle,400,80);
END KstenListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE WeiterKnopfCallback();
VAR Abfragetext : String.TString;
    Titel       : String.TString;
    Leerstring  : String.TString;
    HeuteString : String.TString;
    Heute       : Datum.TDatum;
BEGIN
  (*
     -- AUFRUF KINDFENSTER, mit bergabeparametern VertragsId.PersonalId
     -- und Addresse des aufrufenden Vaterfensters hiks.
     -- Das Vaterfenster wird aus dem soeben zu kreierenden Kindfenster aufgerufen
  *)

  FAnlegen2VtrHKB.Create(CAST(ADDRESS,globalPersID),CAST(ADDRESS,globalKstID),Vater);
  Dispose();

END WeiterKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);

VAR Titel,s     : String.TString;
    Hilfskraft  : HKe.THK;
    Kostenstelle: Ksten.TKst;
    ok          : BOOLEAN;
BEGIN
     ok := TRUE;

     globalVtrID  := String.Create();
     globalPersID := String.Create();
     globalKstID  := String.Create();

     Vater := inFunct;
     Titel := String.Create();

     IF NOT HKe.FirstHK(Hilfskraft) THEN
        s := String.Create();
        String.Schreibe(s," Keine Daten im Hilfskraftordner !! ");
        MeldungAnzeigen(s);
        String.Dispose(s);
        ok := FALSE;
     ELSE
        HKe.DisposeHK(Hilfskraft);
     END;

    IF NOT Ksten.FirstKst(Kostenstelle) THEN
        s := String.Create();
        String.Schreibe(s,"Keine Daten im Kostenstellenordner !!");
        MeldungAnzeigen(s);
        String.Dispose(s);
        ok := FALSE;
    ELSE
        Ksten.DisposeKst(Kostenstelle);
    END;

    IF NOT Konden.VKonditionVorhanden() THEN
        s := String.Create();
        String.Schreibe(s,"Keine Vertragskonditionen vorhanden!!");
        MeldungAnzeigen(s);
        String.Dispose(s);
        ok := FALSE;
    END;

    IF NOT Konden.TKonditionVorhanden() THEN
        s := String.Create();
        String.Schreibe(s,"Keine Tarifkonditionen vorhanden!!");
        MeldungAnzeigen(s);
        String.Dispose(s);
        ok := FALSE;
    END;

    IF ok THEN
       String.Schreibe(Titel,"V e r t r a g   E r z e u g e n  &  B u c h e n");
       FensterHandle :=  NeuesFenster( Titel,100,200,360,560);
       InitMaske();
       ShowContentsOfHke();
       ShowContentsOfKsten();
    ELSE
      DisposeEarly();
    END;

END Create;

(*----------------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
    EntferneFenster(FensterHandle);
    AktiviereVater := CAST(TActVater,Vater);
    AktiviereVater();
END Dispose;
(*----------------------------------------------------------------------------------------*)

PROCEDURE DisposeEarly();
VAR AktiviereVater : TActVater;
BEGIN
    EntferneFenster(FensterHandle);
    AktiviereVater := CAST(TActVater,Vater);
    AktiviereVater();
END DisposeEarly;
(*----------------------------------------------------------------------------------------*)



PROCEDURE Cut(VAR inoutString : String.TString;inStart,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inoutString, dannRckgabe via inoutString*)
VAR ok : BOOLEAN;
BEGIN
  IF (String.Laenge(inoutString) >= 5) THEN
    String.Auslesen (inoutString,inStart,inAnzahl,inoutString);
  END;
END Cut;

(*----------------------------------------------------------------------------------------*)


PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach ARRAY OF CHAR = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)


END FAnlegenVtrHKB.

