(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: SysDatIMPORTE.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:10 $
# $Revision: 1.1.1.1 $
# Bemerkungen: Kompilierfhiger Status ist erreicht! hgw 12.1.2001 17:40
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE SysDatIMPORTE; 

(* Modul zur Bndelung der Importe des TS_SysDat *)

FROM VDat 	IMPORT OpenInVDat, CloseInVDat, ReadLineInVDat, WriteLineInVDat;
FROM VDat 	IMPORT EofInVDat;
FROM String 	IMPORT TString;

PROCEDURE Open(inoutH:THandle; inN: TString; inM:TModus):BOOLEAN;
BEGIN
	RETURN OpenInVDat(inoutH, inN, inM);
END Open;

PROCEDURE Close(inH:THandle):BOOLEAN;
BEGIN
	RETURN CloseInVDat(inH);
END Close;

PROCEDURE ReadLine(inH:THandle; VAR inoutS:TString; VAR inoutM:TString):BOOLEAN;
BEGIN
	RETURN ReadLineInVDat(inH,inoutS,inoutM);
END ReadLine;

PROCEDURE WriteLine(inH:THandle; VAR inoutS:TString; VAR inoutM:TString):BOOLEAN;
BEGIN
	RETURN WriteLineInVDat(inH,inoutS,inoutM);
END WriteLine;

PROCEDURE Eof(inH:THandle):BOOLEAN;
BEGIN
	RETURN EofInVDat(inH);
END Eof;

END SysDatIMPORTE.	



